<?php
/**
 * Description of auktion API
 * All Methode for this AuctionsHouse.
 * @copyright (c) 2013, Mutzii
 * @version 0.2
 * @author Mutzii
 */
class Auction implements tables
{
  use DatabaseTables;  
    
    
    protected static $objItemFilter = null;
    protected static $objItemFilterNext = null;
    protected static $aryItemFilterCategorys = array();
    protected static $aryClasses = array();
    
    protected static $numPlayerNotFound = 2;
    protected static $numNotEnoughMoney = 1;
    protected static $numBuySuccess     = 0;
   
    const _NULL = 0;
    const _ONE  = 1;
    const _TWO  = 2;
    const _THREE = 3;
    const EMPTY_STRING = "";
    
    const HUNDERT_PERCENT = 100;
    
    const TAX_ACTIV = 1;
    const TAX_DEACTIV = 0;
       
    /**
     *  Notice:
     *  AID or $intDatabaseId = APS ID
     *  In the Table: ah_items[id]
     * 
     *  Could not decide. :)
     * 
     *  ItemId is not AID or APS ID. ItemId is only Minecraft ItemId.
     * 
     */
    
   
   // Constructor
   public function __construct() {
       
          
       // Init ItemFilter
       self::$objItemFilter = new ItemFilter(NULL,NULL);
       self::$objItemFilterNext = self::$objItemFilter;
        
       // Item Filter Settings
         $this->createItemFilters(array(
           'Wood','Food','Ori','Stones','Wool','Drinks','Weapon','Armor'
         ));
       
       
       // Wood Items
       $this->getItemFilterAddItems('Wood', array(
           5,17,25,47,54,58,63,64,68,84,125
       ));
       
       // Food Items 
       $this->getItemFilterAddItems('Food', array(
           39,40,83,92,104,105,115,260,281,282,295,296,297,319,320,322,338,344,349,350,353,354,357,360,361,362,363,364,365,366
       ));
       
       // Ori / Erz Items 
       $this->getItemFilterAddItems('Ori', array(
           14,15,16,21,22,41,42,56,57,73,129,133
       ));
       
       // Ori / Erz Items 
       $this->getItemFilterAddItems('Stones', array(
           1,4,7,13,43,44,45,48,49,67,70,77,82,87,89,109
       ));
       
       // Wolle
       $this->getItemFilterAddItems('Wool', array(
           35
       ));
       
       // Drinks
       $this->getItemFilterAddItems('Drinks', array(
           373,374
       ));
       
       // Weapons
       $this->getItemFilterAddItems('Weapon',$this->itemWeaponCreator());       
       
       // Armor
       $this->getItemFilterAddItems('Armor', $this->itemArmorCreator());
       
       
       self::$aryClasses = array(
           
          "Player",
          "Permission",
          "CollectItems"
            
       );
   }
  
    /**
     * Call any Methoden 
     * @param string $strMethodeName
     * @param array $aryArguments
     * @return mixed
     */
    public function __call($strMethodeName, $aryArguments) 
    {
        foreach(self::$aryClasses as $strClassName)
        {
             $class = new $strClassName();
             if(method_exists($class,$strMethodeName)){
                 return call_user_func_array(array($class,$strMethodeName), $aryArguments);
             }
        }
    }
   

   /**
    * All Item Informations
    * @param integer $itemIdentificationsNumber
    * @return array
    */
   public function getItemInfo($itemIdentificationsNumber)
   {
        $aryItemTables = $this->getItemTables();
        $SQL = new MySQL();
        
        $strSql = $SQL->selectSqlData($aryItemTables['it'],false, array(
                  'id' => $itemIdentificationsNumber
              ));

              $result = $SQL->getMysqlQuery($strSql);

              $aryItemInfo = array();
              while($daten = mysql_fetch_assoc($result))
              {
                  $aryItemInfo[0] = $daten;
                  break;
              }

      return $aryItemInfo[0];
   }

   
   /**
    * @param integer $intDatabaseId (AID)
    * @param string $strMoveTo
    * @param string $strPlayerName (optional)
    */
   public function itemBuyAction($intDatabaseId,$strMoveTo = 'postbox',$strPlayerName = false)
   {
      $SQL = new MySql();  
      $player = new Player();
      $aryFinancTables = $this->getFinanceTables();
      
      $numTaxSumme   = self::_NULL;
      $numPriceTotal = self::_NULL;
      $numPriceSumme = self::_NULL;
      
                        if($strPlayerName == false){
                             $strPlayerName = $this->getLoginPlayerName();
                        }
                                                    
              $intPlayerId = $player->getPlayerId($strPlayerName);       

              // Steuer 
              $strSql = $SQL->selectSqlData($aryFinancTables['finance_tax'], array('taxPercent'), array(

                  'taxSelect' => self::TAX_ACTIV // if tax Enabled by 1 

              )); $result = $SQL->getMysqlQuery($strSql);

              // addiere Tax Percent...
              while($daten = mysql_fetch_array($result))
              {
                  $numTaxSumme = $numTaxSumme + $daten['taxPercent'];
              }
              
              // get Item Info
              $aryItemInfo = $this->getItemInfo($intDatabaseId);
              
              //seller Player Name 
              $sellerPlayerId = $player->getPlayerIdfromItem($intDatabaseId,self::TABLE_AUCTION);
              $strSellerPlayerName = $player->getPlayerName($sellerPlayerId);
              
              // get Price with Tax
              $numPriceTotal  = ( $aryItemInfo['itemPrice'] / self::HUNDERT_PERCENT ) * $numTaxSumme;
              $numPriceSumme  = $numPriceTotal + $aryItemInfo['itemPrice'];
              
                   if($player->isPlayerMoney($strPlayerName,$numPriceSumme)){
                            
                         //insert Item 
                         $this->insertAIDItem($intDatabaseId,$intPlayerId,$strMoveTo);
                        /* add Seller Money*/
                         $player->addPlayerMoney($strSellerPlayerName,$aryItemInfo['itemPrice']); // without TAX
                        /* sub Buyer Money*/
                         $player->subPlayerMoney($strPlayerName,$numPriceSumme);                  // with TAX
                        /* Remove ITEM from AuctionsHouse */
                         $this->removeAIDItem($intDatabaseId,$sellerPlayerId,'auctions'); // Remove from Auction  
                        /* Buy Log Action */
                         $this->insertLogBuyAction($aryItemInfo['itemId'],$aryItemInfo['itemBytes'],$intPlayerId,$sellerPlayerId,$intDatabaseId);

                   }else{
                       
                            $exception = new GlobalException('BuyInfo',0,null);
                            $exception->setArray(array(
                                
                                'error' => self::$numNotEnoughMoney,
                                'info'  => array(
                                           'aid'   =>  $intDatabaseId,
                                           'money' =>  $player->getPlayerMoney( $strPlayerName ),
                                           'mode'  =>  0
                                )
                                                           
                            )); throw $exception;
                      
                   }
     
        $exception = new GlobalException('BuyInfo',0,null);
        $exception->setArray(array(
                                
          'error' => self::$numBuySuccess,
          'info'  => array(
                     'aid'   =>  $intDatabaseId,
                     'move'  =>  $strMoveTo,
                     'mode'  =>  0
                     )
                                
        )); throw $exception;
   }
   
   
   public function insertLogBuyAction($itemId,$itemBytes,$playerBuyId,$playerSellId,$aid)
   {
       $SQL = new MySQL();
       $aryItemTables  = $this->getItemTables();
       $strSql = $SQL->insertSqlData($aryItemTables['it_log'], array(
           
           'itemId' => $itemId,
           'itemBytes' => $itemBytes,
           'playerBuyId' => $playerBuyId,
           'playerSellId' => $playerSellId,
           'itemAuctionsId' => $aid,
           'logActionId' => 1
           
           
       ));$SQL->getMysqlQuery($strSql);
       
   }
   
   
    public function insertLogSellAction($itemId,$itemBytes,$playerBuyId,$playerSellId,$aid)
   {
       $SQL = new MySQL();
       $aryItemTables  = $this->getItemTables();
       $strSql = $SQL->insertSqlData($aryItemTables['it_log'], array(
           
           'itemId' => $itemId,
           'itemBytes' => $itemBytes,
           'playerBuyId' => $playerBuyId,
           'playerSellId' => $playerSellId,
           'itemAuctionsId' => $aid,
           'logActionId' => 2
           
           
       ));$SQL->getMysqlQuery($strSql);
       
   }
   
   
   /**
    * Insert Items by Buy Action 
    * @param integer $intDatabaseId (AID)
    * @param integer $intPlayerId
    * @param string $strMoveTo
    */
   public function insertAIDItem($intDatabaseId,$intPlayerId,$strMoveTo)
   {
       $SQL = new MySQL();
       $aryItemTables  = $this->getItemTables();
       $strSql = self::EMPTY_STRING;
       
       switch($strMoveTo)
       {
           case 'auctions':
               $strSql = $SQL->insertSqlData($aryItemTables['it_auctions'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break;
           case 'postbox':
                $strSql = $SQL->insertSqlData($aryItemTables['it_postbox'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break;
           case 'storehouse':
                $strSql = $SQL->insertSqlData($aryItemTables['it_storehouse'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break; 
       }  
        
         $SQL->getMysqlQuery($strSql);
   }
         
  /**
   * @param integer $intDatabaseId (AID)
   * @param integer $intPlayerId
   * @param string $strMoveTo
   */
    public function removeAIDItem($intDatabaseId,$intPlayerId,$strMoveTo)
   {
       $SQL = new MySQL();
       $aryItemTables  = $this->getItemTables();
       $strSql = self::EMPTY_STRING;
       
       switch($strMoveTo)
       {
           case 'auctions':
               $strSql = $SQL->deleteSqlData($aryItemTables['it_auctions'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break;
           case 'postbox':
                $strSql = $SQL->deleteSqlData($aryItemTables['it_postbox'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break;
           case 'storehouse':
                $strSql = $SQL->deleteSqlData($aryItemTables['it_storehouse'], array('id' => $intDatabaseId, 'playerId' => $intPlayerId));
           break; 
       }  
       
         $SQL->getMysqlQuery($strSql);
   }
   

   
    /**
     * get Item Picture Path
     * Example: http://domain.server/image.png
     * 
     * @param integer $ItemID
     * @param integer $ItemByte
     * @return string 
     */  
    public function getItemPicturePath( $intItemAID )
    {
        $SQL = new MySql(); // Create MySql Instance 
        $tplItems = $this->getItemTables();  // get Database Tables 
   
        $itemDetails = $this->getCollectItemDetails( $intItemAID );
                
        $itemId     = $itemDetails->getTypId();
        $itemBytes  = $itemDetails->getData();
        $itemDamage = $itemDetails->getDurability();
        
        if($this->isMaxStackSizeOne( $intItemAID )){
            
            $itemBytes  = 0;
            $itemDamage = 0;
            
        }
       
       // Create SQL Statement only ItemPath
       $strSql = $SQL->selectSqlData($tplItems['it_icons'], array('itemPath'), array(
          
           'itemId' => $itemId,
           'itemBytes' => $itemBytes,
           'itemDamage' => $itemDamage
           
       )); $result  = $SQL->getMysqlQuery($strSql);
       
       $strImagePath = "No Picture Found.";
       
       while($daten = mysql_fetch_array($result)){

            $strImagePath = $daten['itemPath'];
            
          break;
       }
        
      return $strImagePath;
    }
    
    
    public function getItemPrice( $intItemAID ){
        
        $itemInfo = $this->getItemInfo($intItemAID);
        return $itemInfo['itemPrice'];  
    }

    /**
     * get Item Language ID 
     * @param integer $ItemID
     * @param integer $ItemByte
     */
    public function getItemLanguageId( $intItemAID )
    {
        $SQL = new MySql(); // Create MySql Instance 
        $tplItems = $this->getItemTables();  // get Database Tables 

        $itemDetails = $this->getCollectItemDetails($intItemAID);
        
        if(is_object($itemDetails)){
             
            $itemId     = $itemDetails->getTypId();
            $itemBytes  = $itemDetails->getData();
            $itemDamage = $itemDetails->getDurability();
        
        }else{
            throw new Exception("Call: getItemLanguageId [ItemDetails non Object]",0,null);
        }   
        
        if($this->isMaxStackSizeOne( $intItemAID )){
            
            $itemBytes  = 0;
            $itemDamage = 0;
            
        }
        
       // Create SQL Statement only ItemPath
       $strSql = $SQL->selectSqlData($tplItems['it_icons'], array('itemLanguageId'), array(
          
           'itemId' => $itemId,
           'itemBytes' => $itemBytes,
           'itemDamage' => $itemDamage
           
       )); $result  = $SQL->getMysqlQuery($strSql);
       
       $itemLanguageId = 0; 
       
       while($daten = mysql_fetch_array($result)){

            $itemLanguageId  = $daten['itemLanguageId'];
            
          break;
       }
       
       return $itemLanguageId;
    }
    
    
    /**
     * get Item Details 
     * @version 1.0.3
     * @return new ItemDetails()
     */
    public function getCollectItemDetails( $intItemAID ){
        
        $aryTables = $this->getItemTables();
        
        $mysql = new MySQL();
        $sql   = $mysql->selectSqlData($aryTables['it'],false,array(
            'id' => $intItemAID
        ));
        
        $collectItems = new CollectItems();
        $collectItems->collectItem($sql);
        $itemDetails = $collectItems->getItemDetails( $intItemAID );
          
        return $itemDetails;
    }
    
    /**
     * if maxStackSize from Item one is true
     * @param integer $intItemAID
     * @return boolean
     */
    public function isMaxStackSizeOne( $intItemAID ){
        
        $itemDetails = $this->getCollectItemDetails( $intItemAID );
        
        if($itemDetails->getMaxStackSize() == 1){
            return true;
        }
  
       return false;      
    }
    
    
    
    /**
     * get Item Namen 
     * @param integer $itemLanguageId
     * @param string $languageShortcut |de|en
     * @return string
     */
    public function getItemName($itemLanguageId,$languageShortcut = 'en')
    {
       $SQL = new MySql(); // Create MySql Instance 
       $tplLanguage = $this->getLangTables();
   
       // Create SQL Statement only ItemPath
       $strSql = $SQL->selectSqlData($tplLanguage['lang_items'], array($languageShortcut), array(
          
           'id' => $itemLanguageId

       )); $result  = $SQL->getMysqlQuery($strSql);
       
       $itemLanguageName = false; 
       
       while($daten = mysql_fetch_array($result)){

            $itemLanguageName  = $daten[$languageShortcut];
            
          break;
       }
       
      return $itemLanguageName;
    }
	
    /**
     * get User Avatar Image
     * Return: IMG (HTML Code)
     * @param type $strPlayerName
     * @return string
     */
    public function getAvatarImage($strPlayerName){
	  $user_avatar = '<img width="32px" src="http://minotar.net/avatar/'.$strPlayerName.'/100.png"/>';
	  return  $user_avatar;
    }
   
   //*****************  ITEM NAVIGATION   *******************//
   

    /**
     * get Minecraft Item List (all)
     * @param array $aryLimit (show limit)
     * @return array
     */
    public function getItems($selectTable,$playerName = false,$aryItemFilter = false,$aryDatabaseIdFilter = false,$aryLimit = false)
    {
        $tplItems    = $this->getItemTables();
        $SQL         = new MySql();
        
        switch($selectTable)
        {
            case self::TABLE_AUCTION:
                $selectTable = $tplItems['it_auctions'];    // Auctions Items 
                $selectId    = self::TABLE_AUCTION;
                break;
            case self::TABLE_POSTBOX:
                $selectTable = $tplItems['it_postbox'];     // PostBox Items
                $selectId    = self::TABLE_POSTBOX;
                break;
            case self::TABLE_STOREHOUSE:
                $selectTable = $tplItems['it_storehouse'];  // StoreHouse Items 
                $selectId    = self::TABLE_STOREHOUSE;
                break;     
        }
        
       if($playerName != false && is_string($playerName))
       {
           // only Player Items  
           
           // with ItemFilter
           if(is_array($aryItemFilter) || is_array($aryDatabaseIdFilter))
           {
                $aryItemListe = array();
                $strColumn = "";
                
                if(is_array($aryDatabaseIdFilter))
                {
                    $aryItemFilter = $aryDatabaseIdFilter;
                    $strColumn = '.id';
                }else{
                    $strColumn = '.itemId';
                }
                
                $objCollectItems = new CollectItems();
                // Create new Item Liste with Item Filter
                foreach($aryItemFilter as $itemId)
                {
                        $strSql = $SQL->selectLeftJoin(false, array(

                        $selectTable => 'id',   
                        $tplItems['it'] => 'id'

                        ),array(

                        $selectTable.'.playerId' => $this->getPlayerId($playerName),
                        $tplItems['it'].$strColumn => $itemId
                                
                        ),$aryLimit);
                        
                              /* v1.0.3 */
                              $objCollectItems->collectItem($strSql);
//                            $objResult = $SQL->getMysqlQuery($strSql);
//                            $aryItemListe = array_merge($aryItemListe,$this->addItemToListe($objResult,$selectId));        
                }
               
               return $objCollectItems;
//               return $aryItemListe;
               
               
           }else{
                
                // without Item Filter ..
               
                $strSql = $SQL->selectLeftJoin(false, array(

                    $selectTable => 'id',   
                    $tplItems['it'] => 'id'

                ),array(
                    
                    $selectTable.'.playerId' => $this->getPlayerId($playerName)
                    
                ),$aryLimit);
           }
           
           
       }else{
           
           // All Items
           
           // with Item Filter
           if(is_array($aryItemFilter) || is_array($aryDatabaseIdFilter))
           {
                $aryItemListe = array();
                
                
                $strColumn = "";
                
                if(is_array($aryDatabaseIdFilter))
                {
                    $aryItemFilter = $aryDatabaseIdFilter;
                    $strColumn = '.id';
                }else{
                    $strColumn = '.itemId';
                }
                $objCollectItems = new CollectItems();
                // Create new Item Liste with Item Filter
                foreach($aryItemFilter as $itemId)
                {
                        $strSql = $SQL->selectLeftJoin(false, array(

                        $selectTable => 'id',   
                        $tplItems['it'] => 'id'

                        ),array(

                        $tplItems['it'].$strColumn => $itemId
                                
                        ),$aryLimit);
                            
                        
                              /* v1.0.3 */
                              $objCollectItems->collectItem($strSql);
//                            $objResult = $SQL->getMysqlQuery($strSql);
//                            $aryItemListe = array_merge($aryItemListe,$this->addItemToListe($objResult,$selectId));        
                }
               
                 return $objCollectItems;
//               return $aryItemListe;
               
           }else{
           
             // Without Item Filter..
                $strSql = $SQL->selectLeftJoin(false, array(
                    
                    $selectTable => 'id',   
                    $tplItems['it'] => 'id'
  
  
              ),false,$aryLimit);
           }

                
               
        
       }

       
        // exec SQL Query v1.0.2
//        $objResult = $SQL->getMysqlQuery($strSql);  
//        return $strItemListe = $this->addItemToListe($objResult,$selectId);  
       
         /* v1.0.3 */
         $objCollectItems = new CollectItems();
         $objCollectItems->collectItem($strSql);
         return $objCollectItems;
       
    }
    
      
   /**
    * Create HTML Code for ItemListe.
    * @param type $objResult
    * @return string
    */
   private function addItemToListe($objResult,$selectTable){
       
           $aryListe = array();
           
           $counter = 0;
           $save = array();
           
           while($daten = mysql_fetch_object($objResult)){

               $save[$counter] = $daten;
               $counter++;
               
              // Item Path Example: http:/domain.server/itemname.png
               
              $imageurl = $this->getItemPicturePath($daten->id);
              // Item Language ID 
              $itemLanguageId = $this->getItemLanguageId($daten->id);
             
//              echo "LangID:".$itemLanguageId.' :: ';
              // Item Name | Default Settings: English | more Shorcuts: en and de
              $itemName       = $this->getItemName($itemLanguageId,'en');
//              echo $itemName.'<br>';
              $stockPrice     = $daten->itemPrice / $daten->itemStack;
             
              $intPlayerId    = $this->getPlayerIdfromItem($daten->id,$selectTable); // hollt sich nur die PlayerId von Auction Items 
              $strPlayerName  = $this->getPlayerName($intPlayerId);
              
              $daten->itemPrice = number_format($daten->itemPrice,2,',','.');
              $stockprice       = number_format($stockPrice,2,',','.');
                
              $user_avatar = $this->getAvatarImage($strPlayerName);
                   
              $auktionsliste ='
                       					   

                             
                            <ul>
                            <li style="width:5px;">
                                <div class="li_box">
                                  <input type="checkbox" onchange="ShowCart();" name="id" value="'.$daten->id.'">
                                </div>
                            </li>   
                            <li style="width:120px;"><div class="li_box"><a href="javascript:moreinfos('.$daten->id.');" title="more Information"> '.$itemName.' </a></div></li>
                            <li style="width:30px;"><div class="li_box"><img title="Stack: '.$daten->itemStack.'" src="'.$imageurl.'"></img></div></li>
                            <li style="width:30px;"><div class="li_box">'.$daten->itemPrice.'</div></li>
                            <li style="width:30px;"><div class="li_box">'.$stockprice.'</div></li>
                            <li style="width:140px;"><div class="li_box">'.$user_avatar.' '.$strPlayerName.'</div></li>
                                                 
                        </ul> 
					                 
               ';
              
              array_push($aryListe,$auktionsliste);
              
           }
        
          return $aryListe;
   }
   
   
   
   
   
   
   /*
    *  Search via Name the Database Item Id
    */
   public function searchDatabaseIdAlgo($strSearchName,$langShortCut = 'en')
   {
       // First Stept Read ah_language_items
       $aryLangTables  = $this->getLangTables();
       $aryItemTables  = $this->getItemTables();
       
       $SQL = new MySQL();
       
       $strSql = $SQL->selectSqlData($aryLangTables['lang_items']);
       $result = $SQL->getMysqlQuery($strSql);
       
       $intFirstCounter = 0;
       $arySave = array();
       while($daten = mysql_fetch_array($result))
       {
           $arySave[$intFirstCounter] = $daten;
           $intFirstCounter++;
       }
       
       // Filtern....
       $aryItemLanguageIds = array();
       foreach($arySave as $daten)
       {
           if($this->searchAlgo($daten[$langShortCut],$strSearchName))
           {
               array_push($aryItemLanguageIds,$daten['id']);    
           } 
       }
        
 
       
       // Save ItemId and ItemBytes..
       $arySaveIb = array(); 
       foreach($aryItemLanguageIds as $langNumber)
       {
               $strSql = $SQL->selectSqlData($aryItemTables['it_icons'], false, array(
                   'itemLanguageId' => $langNumber
               ));
                        $result = $SQL->getMysqlQuery($strSql);
               
               $intCounter = 0;         
                        
               while($daten = mysql_fetch_array($result))
               {
                   $savedaten[$intCounter] = $daten;
                                      
                  $intCounter++;
               } 
               
           $arySaveIb = array_merge($arySaveIb, $savedaten);
       }
      

             
       //Save Database Item Id
       $arySaveDatabaseItemIds = array();
       $intCounter = 0;  
       
       foreach($arySaveIb as $strColumnContent)
       {
           $strSql = $SQL->selectSqlData($aryItemTables['it'], false, array(
              
                'itemId' => $strColumnContent['itemId'],
                'itemBytes' => $strColumnContent['itemBytes'] 
           ));   
                 $result = $SQL->getMysqlQuery($strSql);
           
           while($daten = mysql_fetch_array($result))
           {
                array_push($arySaveDatabaseItemIds,$daten['id']); 
           }
          $intCounter++;
       }
       
       
      return $arySaveDatabaseItemIds;
   }
   
   
   /**
    * 
    * @param string $strContent
    * @param string  $strSearch
    * @return boolean
    */
   private function searchAlgo($strContent,$strSearch)
   {
       if(is_string($strContent) && is_string($strSearch))
       {
              $strMasterContent = $strContent;
              $strContentSize = strlen($strContent);
          
           for($firstSearchSize = 0; $firstSearchSize <= $strContentSize ; $firstSearchSize++)
           {
               $strContent = substr($strMasterContent,0,$firstSearchSize);
               if(strcmp($strContent,$strSearch) == false)
               {
                  return true;   
               }else{
                   //Debug Mode
                   //print_r('Content:'.$strContent.' == '.$strSearch.' <br> ');
               }     
           }  
       }
       return false;
   }
   
   
   
   
   
   //***************** ITEM / ITEM FILTER METHODEN *******************//
   
    /**
     * The Numbers here is Minecraft Item IDs.
     * Other Items..
     * @return array
     */
    public function otherItems(){
        
         $aryfilterItemIds = $this->getItemFilterAllItemIds();
	 $aryother = array();
	 
	 $size = count($aryfilterItemIds);
	 $f    = false;
	 
	 for($x=0; $x < 3000; $x++){
	    for($y=0; $y < $size; $y++){
			if($aryfilterItemIds[$y] == $x){
			    $f = true;
			    break;
			}else{
                $f = false;
            }			
	   }
	   
	   if($f == false){
	        array_push($aryother,$x);
	   }
	  
	 }
	
	 return $aryother;   
    }
   
   
   /**
    * The Numbers here is Minecraft Item IDs.
    * item Armor Creator
    * @return array
    */
   public function itemArmorCreator(){
      
      $_array = array();

      for($x=298; $x <= 317; $x++){
         array_push($_array,$x);
      }
      
     return $_array;
   }
   
   /**
    * The Numbers here is Minecraft Item IDs.
    * item Weapon Creator 
    * @return array
    */
   public function itemWeaponCreator()
   {
       $_array = array();

              array_push($_array,261); // Bow
              array_push($_array,346); // Fishing Rod
    
       for($x=256; $x <= 258; $x++){
              array_push($_array,$x);
       }      
 
       for($x=267; $x <= 279; $x++){
              array_push($_array,$x);
       }

       for($x=283; $x <= 286; $x++){
              array_push($_array,$x);
       }

       for($x=290; $x <= 294; $x++){
              array_push($_array,$x);
       }
      
     return $_array;
   }
   
   
   /**
    * Create ItemFilters 
    * @param type $aryItemCategorys
    */
   public static function createItemFilters($aryItemCategorys)
   {
       if(is_array($aryItemCategorys)){

           self::$aryItemFilterCategorys = array_merge(self::$aryItemFilterCategorys,$aryItemCategorys);
           
           foreach($aryItemCategorys as $strValue)
           {
               self::setItemFilter($strValue, array());
           }  
       }       
   }
   
   /**
    * get Item Filter Categorys
    * Retrun Array 
    * @return type
    */
   public static function getItemFilterCategorys()
   {
       return self::$aryItemFilterCategorys;
   }
   
   /**
    * Create a New ItemFilter Category with array(items)
    * @param type $strItemCategory
    * @param type $aryItemIds
    */
   public static function setItemFilter($strItemCategory,$aryItemIds)
   {
     if(is_array($aryItemIds)){
        self::$objItemFilterNext->nextFilter = new ItemFilter($strItemCategory,$aryItemIds);
        self::$objItemFilterNext = self::$objItemFilterNext->nextFilter;
     }   
   }
   
   /**
    * All Item IDs that were set by the filter are joined together in an array.
    * Return AllItem Array.
    * @return type
    */
   public function getItemFilterAllItemIds()
   {
       $aryCategorys = $this->getItemFilterCategorys();
       $aryAllItems  = array();

       foreach($aryCategorys as $strItemCategory){
         $aryAllItems  = array_merge($aryAllItems,$this->getItemFilterIDs($strItemCategory));
       }
       
       return $aryAllItems;
   }
   
   /**
    * get Array ItemIDS from Category.
    * 
    * Example:
    * Category: Wolle 
    * get Array: array(35); // ItemID 35
    * 
    * @param type $strItemCategory
    * @return type
    */
   public static function getItemFilterIDs($strItemCategory){
       $objFilter = self::searchItemFilter(self::$objItemFilter, $strItemCategory);
       return $objFilter->getItemArray();
   }
   
   /**
    * get Size from Items the Category
    * @param type $strItemCategory
    * @return type
    */
   public static function getItemFilterIdsSize($strItemCategory){
       $objFilter = self::searchItemFilter(self::$objItemFilter, $strItemCategory);
       return $objFilter->getItemArraySize();
   }
   
   /**
    * add Items to Categorty 
    * Example: getItemFilterAddItems('Wolle',array(20,34,212))
    * Notice: the Category must already Exists.
    * 
    * @param type $strItemCategory
    * @param type $aryItemIds
    * @return type
    */
   public static function getItemFilterAddItems($strItemCategory,$aryItemIds)
   {
       $objFilter = self::searchItemFilter(self::$objItemFilter, $strItemCategory);
       return $objFilter->addItems($aryItemIds);  
   }
   
   /**
    * Remove a Item from Category 
    * Example: getItemFilterRemoveItem('Wolle',35);
    * 
    * @param type $strItemCategory
    * @param type $intItemId
    * @return type
    */
   public static function getItemFilterRemoveItem($strItemCategory,$intItemId)
   {
       $objFilter = self::searchItemFilter(self::$bjItemFilter, $strItemCategory);
       return $objFilter->removeItem($intItemId);  
   }
   
   /**
    * Remove All ItemIDs from Category
    * @param type $strItemCategory
    * @return type
    */
   public static function getItemFilterClear($strItemCategory)
   {
       $objFilter = self::searchItemFilter(self::$objItemFilter, $strItemCategory);
       return $objFilter->Clear();
   }
   
   /**
    * ItemFilter Search Category Object into the Structur.
    * It is only necessary to filter extensions.
    * @param type $objItemFilter
    * @param type $strItemCategory
    * @return boolean
    */
   private static function searchItemFilter($objItemFilter,$strItemCategory)
   {
        if($objItemFilter != null){
            if($objItemFilter->nextFilter != null){
                
                 if(strcmp($objItemFilter->nextFilter->getItemCategory(),$strItemCategory) != false){
                     
                     return self::searchItemFilter($objItemFilter->nextFilter,$strItemCategory);
                 }else{
                     return $objItemFilter->nextFilter;
                 }    
                
            }
            return $objItemFilter;
        }
        
       return false;
   }
    
}


/**
 *  little Item Database
 *  Name: ItemFilter
 */
class ItemFilter
{
    
    protected $strItemCategory = null;
    protected $aryItemIDs = array();
    public    $nextFilter = null;
    
    // Saved Index Category and ItemArray
    public function __construct($itemCategory,$itemIds) {
        $this->aryItemIDs = $itemIds;
        $this->strItemCategory = $itemCategory;
    }
    
    // get Item Category
    public function getItemCategory(){
        return $this->strItemCategory;
    }
    
    // get Item Array IDs
    public function getItemArray(){
        return $this->aryItemIDs;
    }
    
    // get Item Array Size
    public function getItemArraySize(){
        return count($this->aryItemIDs);
    }
    
    // add Items to Array 
    public function addItems($itemsArrayorString)
    {
        if(is_array($itemsArrayorString)){
            $this->aryItemIDs = array_merge($this->aryItemIDs,$itemsArrayorString);
        }else{
            array_push($this->aryItemIDs,$itemsArrayorString);
        } 
       return true;
    }
    
    // Remove one Item from Array
    public function removeItem($itemID){
        $pos = array_search($itemID, $this->aryItemIDs); // Array Item Position
        unset($this->aryItemIDs[$pos]); // Array[position] Remove
        return true;
    }
    
    // Clear the ItemID Array.
    public function Clear(){
        unset($this->aryItemIDs);
        return true;
    }
    
}



?>
