<?php

/**
 *  Controller Filter
 *  Checkt the Directorys for more Controllers
 */

class ControllerFilter
{
   protected static $aryFilter = array();  
   const nothing = ""; 
   
   
    public function __construct($aryFilter) {
        
        $this->setFilter($aryFilter);
    }
    
    /**
     * set Array Filter
     * @param type $aryFilter (normal Array)
     */
    public static function setFilter( $aryFilter )
    {
        self::$aryFilter = $aryFilter;
    }
    
    /**
     * get Array Filter
     * @return array (normal Array)
     */
    public static function getFilter()
    {
       return is_array(self::$aryFilter)? self::$aryFilter : false;
    }
    
   
    /**
     * Search Controller Name in the Directorys and Include this
     * @param string  $controllerName
     * @return boolean found:true 
     */
    public static function searchController( $controllerName )
    {
       $controllerTarget = null;
       
       if(is_array(self::$aryFilter) && count(self::$aryFilter) != null){
            
            foreach(self::$aryFilter as $strFilterContent)
            {
                if(is_string($strFilterContent) && is_string($controllerName))
                { 
                   $target = AHROOT. '/controllers/' . $strFilterContent . $controllerName. '.php'; 

                   if(file_exists($target)){
                       $controllerTarget = $target;
                       require_once($controllerTarget);
                       break;
                   }
                }
            }
            
        }
         
      return is_null($controllerTarget)? false : true;
    }
    
    /**
     * Search all Element from Array and Filter the from strContent
     * @param string $strContent be filtered
     * @return string  filtered text
     */
    public static function activFilter( $strContent )
    {
        if(is_array(self::$aryFilter) && count(self::$aryFilter) != null){
            
            foreach(self::$aryFilter as $strFilterContent)
            {
                if(is_string($strFilterContent) && is_string($strContent))
                { 
                  $strContent =  self::stringReplace($strFilterContent,self::nothing, $strContent);   
                }
            }
            
        }
        
       return is_string($strContent)? $strContent : false;
    }
    
    /**
     * Replace String Content with $strReplace
     * @param string $strSearch
     * @param string $strReplace
     * @param string $strContent
     * @return string|boolean
     */
    private static function stringReplace($strSearch,$strReplace,$strContent)
    {
       return is_string($strContent)? str_replace($strSearch,$strReplace,$strContent):false;
    }
    
}


?>
