<?php

/**
 * Session Class
 * Created | Destroyed and set Sessions
 * @author Azubi Team 
 */
class Session
{
   const nothing = " ";  
    
    public function __construct($autoSessionStart = false){
        
        if($autoSessionStart != false)
        {
            $this->sessionStart();
        }    
    }
    
    /**
     * Start new Session
     */
    public function sessionStart()
    {
        if($this->getSessionId() == self::nothing){
            session_start();
        }
    }
    
    /**
     * Destroys all data registered to a session
     */
    public function sessionDestroy()
    {
        session_destroy();
    }
    
    /**
     * Free all session variables
     */
    public function removeAllSessions()
    {
        session_unset();
    }
    
    /**
     * @return integer  session_id
     */
    public function getSessionId()
    {
        return session_id();
    }
    
    /**
     * @return string SessionName
     */
    public function getSessionName()
    {
        return session_name();
    }
    
    /**
     * @param string $strSessionName SessionName
     */
    public function setSessionName($strSessionName)
    {
        session_name($strSessionName);
    }
       
    /**
     * Create Session or Set Session
     * @param string  $strIndex SessionName
     * @param string  $strValue SessionValue
     */
    public function createSession($strIndex,$strValue)
    {
        $_SESSION[$strIndex] = $strValue;
    }
    
    /**
     * get SessionName and Check if it is not empty.
     * If Session Empty return false
     * @param string $strSessionName SessionName
     * @return string|boolean
     */
    public function getSession($strSessionName)
    {
       if(isset($_SESSION[$strSessionName]) && !empty($_SESSION[$strSessionName]))
       {
           return $_SESSION[$strSessionName];
       }
       
      return false;
    }
       
}
