<?php

class ItemDetails
{
    private $aryCurrentItem = array();
    const ITEM_ID          = 0;
    const ITEM_STACK       = 1;
    const ITEM_BYTES       = 2;
    const ITEM_DAMAGE      = 3;
    const ITEM_MAXSTACK    = 4;
    const ITEM_ENCHANTMENT = 5;
    
    
    public function __construct( $aryItemDetails ) {
        
        $this->setItemDetails($aryItemDetails);
    }
    
     /**
      * set Item Details 
      * @param array $aryNewItem
      */
    public function setItemDetails( $aryItemDetails ){
        
      if(is_array( $aryItemDetails )){
        $this->aryCurrentItem = $aryItemDetails;
      }
    }
    
    /**
     * get Item Details 
     * @return array
     */
    public function getItemDetails(){
        return $this->aryCurrentItem;
    }
    
    /**
     * get Item Id 
     * @return string
     */
    public function getTypId(){
        return $this->aryCurrentItem[self::ITEM_ID];
    }
    
    /**
     * get Item Stack Size 
     * @return string
     */
    public function getAmount(){
        return $this->aryCurrentItem[self::ITEM_STACK];
    }
    
    /**
     * get Item Bytes 
     * @return string
     */
    public function getData(){
        return $this->aryCurrentItem[self::ITEM_BYTES];
    }
    
    /**
     * get Item Damage 
     * @return type
     */
    public function getDurability(){
        return $this->aryCurrentItem[self::ITEM_DAMAGE];
    }
    
    
    /**
     * get Item Max StackSize 
     * @return string
     */
    public function getMaxStackSize(){
        return $this->aryCurrentItem[self::ITEM_MAXSTACK];
    }
    
    /**
     * get Enchantments
     * @return object
     */
    public function getEnchantments(){
        return $this->aryCurrentItem[self::ITEM_ENCHANTMENT];
    }
    
}


?>
