<?php

class Message extends Factory
{
    public function __construct() {
        parent::__construct();
    }
    
    protected static $aryMessage = array();
    
    
    const SUCCESS   = 0;
    const ERR_MONEY = 1;
    
    const MODE_DEFAULT = 0;
    const MODE_BUY  = 0;
    const MODE_SELL = 1;
    const MODE_MERGE_ITEMS = 1;
    const MODE_REMOVE_ITEMS = 2;
    
    const MOVETO_AUCTION = 'auction';
    const MOVETO_POSTBOX = 'postbox';
    const MOVETO_STOREHOUSE = 'storehouse';
    
    private function equals($strFirst,$strSecond)
    {
        if(strcmp($strFirst,$strSecond) == false)
                return true;
        
       return false;
    }
    
    
    private function getMoveLabel($strMoveTo)
    {
        if($this->equals($strMoveTo, self::MOVETO_AUCTION))
            return array(
              
                'firstLabel'  => 'LBL_MOVE_AUCTION',
                'secondLabel' => 'LBL_AUCTION'
                
                
            );
        if($this->equals($strMoveTo, self::MOVETO_POSTBOX))
            return array(
              
                'firstLabel'  => 'LBL_MOVE_POSTBOX',
                'secondLabel' => 'LBL_POSTBOX'
                
                
            );
        if($this->equals($strMoveTo, self::MOVETO_STOREHOUSE))
            return array(
              
                'firstLabel'  => 'LBL_MOVE_STOREHOUSE',
                'secondLabel' => 'LBL_STOREHOUSE'
                  
            );
    }
    
    
    private function createSuccessArray($intAID,$strMoveTo)
    {
       $objTranslateModel = $this->loadModel('translate'); 
       $objItemInfoModel  = $this->loadModel('itemInfo');
       
       $aryItemInfo = $objItemInfoModel->getItemInfo($intAID);
       $strItemName = $objItemInfoModel->getItemName($intAID);
       
       $strFirstLabel  = $this->getMoveLabel($strMoveTo)['firstLabel'];
       $strSecondLabel = $this->getMoveLabel($strMoveTo)['secondLabel'];
       
       $strMoveTo      = $objTranslateModel->getTransLateLabelinLabel($strFirstLabel,$strSecondLabel);
       
       $message = '['.$strItemName.'] '.$strMoveTo;
       
       $this->addInfo($intAID, $message, '');
    }
    
    public function addInfo($intAid,$strMessage,$strTitle,$intSelectImage = 0)
    {
       array_push(self::$aryMessage,array(
           
             'aid'   => $intAid,
             'msg'   => $strMessage,
             'title' => $strTitle,
             'image' => $intSelectImage     
       ));
    }
    
     
    public function addInformations( $aryGlobalException )
    {
        
        $objTranslateModel = $this->loadModel('translate');
        $intErrorCode = $aryGlobalException['error'];
        
                // create Success Message 
                if($intErrorCode == self::SUCCESS)
                {
                     $aryInfo         = $aryGlobalException['info'];
                     $intModeCode     = $aryInfo['mode'];
                     
                            if($intModeCode == self::MODE_DEFAULT)
                            {
                                $this->createSuccessArray($aryInfo['aid'],$aryInfo['move']);
                            }
                            
                            if($intModeCode == self::MODE_MERGE_ITEMS)
                            {
                                $MasterAID     = $aryInfo['aid'];
                                $boolRemove    = $aryInfo['remove'];
                                $newStackSize  = $aryInfo['stack'];
                                
                                $objItemInfoModel    = $this->loadModel('itemInfo');
                                $aryItemInfo         = $objItemInfoModel->getItemInfo($MasterAID);
                                $strItemName         = $objItemInfoModel->getItemName($MasterAID);
                                
                                if($boolRemove)
                                {
                                  $strMessage = '[Info] '.$strItemName.' Removed.';  
                                }else{
                                  $strMessage = '[Info] '.$strItemName.' new Stack Size:'.$newStackSize; 
                                }
                                
                                $this->addInfo($MasterAID,$strMessage,'',0);  
                                
                            }
                            //Success Removed
                            if($intModeCode == self::MODE_REMOVE_ITEMS){
                                $strItemName = $aryInfo['itemname'];
                                $this->addInfo($aryInfo['aid'],'[Info] Item ['.$strItemName.'] Removed.','Item Removed',0);    
                                
                           }
                
                }
                
                // create Not Enough Money Message
                if($intErrorCode == self::ERR_MONEY)
                {
                    $aryInfo         = $aryGlobalException['info'];
                    $intModeCode     = $aryInfo['mode'];
                    
                        if($intModeCode == self::MODE_DEFAULT)
                        {
                          $this->addInfo($aryInfo['aid'],'[Info] '.$objTranslateModel->getTranslateLabel('LBL_NOT_ENOUGH_MONEY'),'Last Money:'.$aryInfo['money'],1);  
                        }
                }
                
                //Fail
                if($intErrorCode == self::MODE_REMOVE_ITEMS){
                    
                    if($intModeCode == self::MODE_REMOVE_ITEMS){
                                   
                          $this->addInfo($aryInfo['aid'],'[Info] Item dont Removed.','Item dont Removed',1);       
        
                    }
                }
                
 
    }
    
    
    public function createMessage()
    {
      $createMessage = self::EMPTY_STRING; 
      
        foreach(self::$aryMessage as $information)
        {
           if($information['image'] == 0)
           {
               $img = 'assets/img/green.gif';
           }
           
           if($information['image'] == 1)
           {
               $img = 'assets/img/rotes_x.gif';
           }
           
            $createLink  = '<a href="javascript:moreinfos('.$information['aid']. ')"> '.$information['aid']. ' </a>';
           
            $createMessage .= '<tr>';
            $createMessage .= '<td width="10px">'.$createLink.'</td> <td width="310px" title="'.$information['title'].'">'.$information['msg'].'</td> <td width="90px"> <img src="'.$img.'"></img> </td>';
            $createMessage .= '</tr>';           
        }
        
      return $createMessage; 
    }
    

    public function Show()
    {
        return $this->createMessage();  
    }
    
    
   
}


?>
