<?php
class SelectAction extends Factory
{
    private static $aryOptions = array();
    private static $strMasterOption = self::EMPTY_STRING;
    
    
    public function __construct() {
        parent::__construct();
        
        self::$aryOptions = array();
        self::$strMasterOption = self::EMPTY_STRING;
        
    }
    
    /** 
     * @param string $strTitle
     * @param string $strLabelText
     * @param boolean $isSelected
     */
    public static function addSelectMasterOption($strTitle,$strLabelText,$isSelected = true)
    {
        if($isSelected != false)
        {
            self::$strMasterOption = '<option title="'.$strTitle.'" selected> '.$strLabelText.' </option>';
            
        }else{
            
            self::$strMasterOption = '<option title="'.$strTitle.'"> '.$strLabelText.' </option>';
        }
       
    }
    
    /**
     * add Options
     * @param string $strJavaScriptMethode
     * @param string $strTitle
     * @param string $strLabelText
     */
    public static function addSelectOptions( $strJavaScriptMethode, $strTitle,$strLabelText)
    {
       $option = array(
         
          'methode' => $strJavaScriptMethode,
          'title'   => $strTitle,
          'label'   => $strLabelText
             
       );

       self::$aryOptions = array_merge(self::$aryOptions,array($option));
    }
    
    /**
     * @return array
     */
    public function getOptionsAsArray()
    {
        return self::$aryOptions;
    }
    
    /**
     * Crate Select Options HTML Code
     * @return string
     */
    public function createHtmlOptions()
    {
       $strResultOption = self::EMPTY_STRING; 
       $strOption = self::EMPTY_STRING; 
        
         foreach(self::$aryOptions as $aryOption)
         {
             $methode = $aryOption['methode'];
             $title   = $aryOption['title'];
             $label   = $aryOption['label'];
                          
             $strOption .= '<option onClick="'.$methode.'" title="'.$title.'"> '.$label.' </option>';        
         }
        
       $strResultOption .= self::$strMasterOption;  
       $strResultOption .= $strOption;
       
       return $strResultOption; 
    }
    
    
    
}


?>