<?php

class viewItems extends Factory
{
   protected static $timer = null;
    
    public function __construct() {
        parent::__construct();
    }
    
    /**
     * Show all Items or with Filter ...
     * @param array $aryLimit exmpale: array(0,1)
     * @return array
     */
    public function getAuctionsItemsAll($filterNumber = false,$aryLimit = false)
    {
        
        self::$timer = microtime(true);
        $liste = parent::$objAuctionsAPI->getItems(0,false,$this->selectItemFilter($filterNumber),false,$aryLimit); // All Items from AuctionsHouse 
        
        if(is_object($liste)){
            return $this->createItemListe($liste);
        }
        
//        return $this->ViewListe($liste);
    }
    
    /**
     * List all Items from Auctions with
     *   SearchIndex Parameter ( Search Methode)
     * @param string $playerName
     * @param string $strSearchName
     * @param array $aryLimit
     * @return array
     */
    public function getAuctionsItemsWithSearchIndex($strSearchName, $aryLimit = false)
    {
        self::$timer = microtime(true);
        $aryDatabaseIds = parent::$objAuctionsAPI->searchDatabaseIdAlgo($strSearchName,'en');
        $liste = parent::$objAuctionsAPI->getItems(0,false,false,$aryDatabaseIds,$aryLimit); // All Items from AuctionsHouse 
        if(is_object($liste)){
            return $this->createItemListe($liste);
        }   
    }
    
    
    /**
     * List all Item from Auctions with 
     *   only LoginPlayerName
     *   and  ItemFilter  (Navigation) 
     * 
     * @param string $playerName
     * @param string $filterNumber
     * @param array $aryLimit
     * @return array
     */
    public function getAuctionsItems($playerName,$filterNumber = false,$aryLimit = false)
    {
       self::$timer = microtime(true); 
       $liste = parent::$objAuctionsAPI->getItems(0,$playerName,$this->selectItemFilter($filterNumber),false,$aryLimit); // List all Items from Auctions via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    /**
     * List all Items from Auctions with
     *   only LoginPlayerName
     *   and with SearchIndex Parameter ( Search Methode)
     * @param string $playerName
     * @param string $strSearchName
     * @param array $aryLimit
     * @return array
     */
    public function getAuctionsItemsWithPlayerAndSearchIndex($playerName,$strSearchName,$aryLimit = false)
    {
       self::$timer = microtime(true);
       $aryDatabaseIds = parent::$objAuctionsAPI->searchDatabaseIdAlgo($strSearchName,'en');
       $liste = parent::$objAuctionsAPI->getItems(0,$playerName,false,$aryDatabaseIds,$aryLimit); // List all Items from Auctions via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    /**
     * List all Item from PostBox with 
     *   only LoginPlayerName
     *   and  ItemFilter  (Navigation) 
     * 
     * @param string $playerName
     * @param string $filterNumber
     * @param array $aryLimit
     * @return array
     */
    public function getPostBoxItems($playerName,$filterNumber = false,$aryLimit = false)
    {
       self::$timer = microtime(true); 
       $liste = parent::$objAuctionsAPI->getItems(1,$playerName,$this->selectItemFilter($filterNumber),false,$aryLimit); // List all Items from Postbox via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    /**
     * List all Items from Postbox with
     *   only LoginPlayerName
     *   and with SearchIndex Parameter ( Search Methode)
     * @param string $playerName
     * @param string $strSearchName
     * @param array $aryLimit
     * @return array
     */
    public function getPostBoxItemsWithPlayerAndSearchIndex($playerName,$strSearchName,$aryLimit = false)
    {
       self::$timer = microtime(true);
       $aryDatabaseIds = parent::$objAuctionsAPI->searchDatabaseIdAlgo($strSearchName,'en');
       $liste = parent::$objAuctionsAPI->getItems(1,$playerName,false,$aryDatabaseIds,$aryLimit); // List all Items from Postbox via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    /**
     * List all Item from StoreHous with 
     *   only LoginPlayerName
     *   and  ItemFilter  (Navigation) 
     * 
     * @param string $playerName
     * @param string $filterNumber
     * @param array $aryLimit
     * @return array
     */
    public function getStoreHouseItems($playerName,$filterNumber = false,$aryLimit = false)
    {
       self::$timer = microtime(true); 
       $liste = parent::$objAuctionsAPI->getItems(2,$playerName,$this->selectItemFilter($filterNumber),false,$aryLimit); // List all Items from StoreHouse via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    /**
     * List all Items from StoreHouse with
     *   only LoginPlayerName
     *   and with SearchIndex Parameter ( Search Methode)
     * @param string $playerName
     * @param string $strSearchName
     * @param array $aryLimit
     * @return array
     */
    public function getStoreHouseItemsWithPlayerAndSearchIndex($playerName,$strSearchName,$aryLimit = false)
    {
       self::$timer = microtime(true);
       $aryDatabaseIds = parent::$objAuctionsAPI->searchDatabaseIdAlgo($strSearchName,'en');
       $liste = parent::$objAuctionsAPI->getItems(2,$playerName,false,$aryDatabaseIds,$aryLimit); // List all Items from StoreHouse via PlayerName
       if(is_object($liste)){
            return $this->createItemListe($liste);
        }
    }
    
    
    /**
     * ItemFilterNumber from 2 - 10 
     * @param integer $intItemFilterNumber
     */
    private function selectItemFilter($intItemFilterNumber = false)
    {
        $aryItemFilter = array();
       
         if($intItemFilterNumber != false){
             
                switch($intItemFilterNumber)
                {
                   case 2:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Stones');
                       break;
                   case 3:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Wood');
                       break; 
                   case 4:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Ori');
                       break;
                   case 5:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Wool');
                       break;
                   case 6:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Weapon');
                       break;
                   case 7:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Armor');
                       break;
                   case 8:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Food');
                       break;
                   case 9:
                       $aryItemFilter = parent::$objAuctionsAPI->getItemFilterIDs('Drinks');
                       break;
                   case 10:
                       $aryItemFilter = parent::$objAuctionsAPI->otherItems();
                       break;
                   default:
                       $aryItemFilter = false;
                       break;
                }
                
         }else{
              $aryItemFilter = false;
         }
        
      return $aryItemFilter; 
    }
    
    
    /* v1.0.3*/
    private function createItemListe($collectItemsObject){
        
        $ss = new Session();
        /* new Items */
        $objItems     = $collectItemsObject->getItems();
        $aryItems     = $objItems->getItems();
        $getItemsSize = $objItems->getSize();
        
        $strContent = self::EMPTY_STRING;
        
        foreach($aryItems as $itemIdentificationsNr => $objItemDetails){
            
                $itemAidNumber = $this->getItemAid( $itemIdentificationsNr );
                
                $itemId           = $objItemDetails->getTypId();
                $itemStack        = $objItemDetails->getAmount();
                
                $itemImageUrl     = parent::$objAuctionsAPI->getItemPicturePath($itemAidNumber);
                $itemLanguageId   = parent::$objAuctionsAPI->getItemLanguageId($itemAidNumber);
                $itemName         = parent::$objAuctionsAPI->getItemName($itemLanguageId,'en');
                $itemPrice        = parent::$objAuctionsAPI->getItemPrice( $itemAidNumber );
                         
                
                
                $strContent .= '
                    
                   <li style="height: 25px; font-size: 13px; margin-top: 25px;"> Action: 
                        <button title="show Item Details " name="details" onClick="javascript:moreinfos('.$itemAidNumber.');"></button>
                        ';
                
                            if($ss->getSession('profilAction') == 'index'){
                    
                               $strContent .= '
                                   <button title="Buy Item (move to Postbox) " name="buyitem" onClick="javascript:ItemBuy(1,'.$itemAidNumber.');"></button>
                                   <button title="add Item into Your Shop Cart " name="cartbox" onClick="javascript:ShowCart('.$itemAidNumber.');"></button>
                               ';   
                            }
                
                            if($ss->getSession('profilAction') == self::TABLE_AUCTION_STRING){

                               $strContent .= '
                                   <button title="Move Item (move to Postbox) " name="moveitem" onClick="javascript:move('.$itemAidNumber.');"></button>

                               ';   
                            }
                            
                            if($ss->getSession('profilAction') == self::TABLE_POSTBOX_STRING){
                    
                               $strContent .= '
                                   <button title="Move Item (move to Storehouse) " name="moveitem" onClick="javascript:move('.$itemAidNumber.');"></button>
                                   <button title="Remove Item " name="removeitem" onClick="javascript:removeItem('.$itemAidNumber.');"></button>
                               ';   
                            }
                
                            if($ss->getSession('profilAction') == self::TABLE_STOREHOUSE_STRING){

                               $strContent .= '
                                   <button title="Move Item (move to Postbox) " name="moveitem" onClick="javascript:move('.$itemAidNumber.');"></button>
                                   <button title="Remove Item " name="removeitem" onClick="javascript:removeItem('.$itemAidNumber.');"></button>
                               ';   
                            }
                
                $strContent.= '
                   </li>
                ';
                
                
                $strContent .= '
                   <li>
                          <span> x'.$itemStack.' 
                             <img title="Stack: '.$itemStack.' "src="'.$itemImageUrl.'"></img> 
                                 '.$itemName.' 
                                   '.$itemPrice.' Coins  
                                         
                            </span></li>';

                
        }
        
        //If Result Null 
        if($getItemsSize == 0){
            
            $strContent = '<li> Not Items found </li>';
            
        }
        
        
        
        
         $time_end = microtime(true);
         $currentTimer = $time_end - self::$timer;
         $time = number_format($currentTimer,4,',','.');
                 
         return array(
             "auction_item_liste" =>  $strContent,
             "auction_item_size"  =>  $getItemsSize,
             "item_result_time"   =>  $time
         );            
    }
    
    
    private function getItemAid( $string ){
        $explodeItemIdNumber = explode('id_',$string);
        return $explodeItemIdNumber[1];
    }
    
    
    
    /**
     * v. 1.0.2
     * Create ViewListe from Item Liste 
     * @param array $liste from navItems
     */
    private function ViewListe($liste){
	
        if(is_array($liste)){
            
            $strContent = "";
            $intContentSize = count($liste);
            
            
          
            
            foreach($liste as $content)
            {
                $strContent .= $content;
            }
            
            if($intContentSize == 0)
            {
                $strContent = '
                     
                         <ul>
                            <li style="width:560px;">
                                <div class="li_box">
                                    <p>No Items Found. :(</p>
                                </div>
                            </li>                          
                        </ul> 


                 ';
            }
            
            $time_end = microtime(true);
            $currentTimer = $time_end - self::$timer;
            $time = number_format($currentTimer,4,',','.');
            
            
            $aryPlaceHolder = array(
                   "auction_item_liste" =>  $strContent,
                   "auction_item_size"  =>  $intContentSize,
                   "item_result_time"   =>  $time
            ); 
          
          return $aryPlaceHolder;
        }
        
    }
      
}


?>
