<?php

/**
 *  Connect to Database Server and get SQL Syntax Strings.
 *  @Description: MySQL Class 
 *  @copyright (c) 2012, Mutzii
 */
class MySql
{
    //constante
    
    const one = 1;
    const two = 2;
    const nothing = " ";
    
    const opAND      = 0; // operator AND
    const opBigAs    = 1; // operator >=
    const opLittleAs = 2; // operator <=
    const opUnequal  = 3; // operator !=
    const opIsis     = 4; // operator ==
    const opIs       = 5; // operator =
    const opOr       = 6; // operator OR
    
    /**
     * Connect to MySQL Database Server with Constructor.
     * Example: new MySQL(array(
     *   'server' => 'localhost',
     *   'name'   => 'myName',
     *   'pass'   => 'myPassword'
     * ),true);
     * 
     * @param array $aryConnect
     * @param boolean $autoConnect
     */
    public function __construct($aryConnect = false,$autoConnect = false) {
        
        if($autoConnect != false && is_array($aryConnect))
        {
            $this->connectToServer($aryConnect['server'], $aryConnect['user'], $aryConnect['pass']);
        }
     
    }
    
    /**
     * Try to Connect to MySQL Database Server.
     * Example: connectToServer('localhost','myname',mypass);
     * @param string $strServer
     * @param string $strUserName
     * @param string $strUserPassword
     * @return boolean
     * @throws Exception
     */
    public function connectToServer($strServer,$strUserName,$strUserPassword)
    {
        $result = mysql_connect($strServer,$strUserName,$strUserPassword);
            if(!$result)
            {
                throw new Exception(mysql_error());
            }else{
                return true;
            } 
    }
    
    /**
     * Select Database Name for Read/Write
     * @param string $strDatabaseName
     * @return boolean
     * @throws Exception
     */
    public function selectDatabase($strDatabaseName)
    {
        $result = mysql_select_db($strDatabaseName);
        
            if(!$result)
            {
                throw new Exception(mysql_error());
            }else{
                return true;
            } 
    }
    
    /**
     * get MySql Query Resource
     * @param string $strSql
     * @return resource
     * @throws Exception
     */
    public function getMysqlQuery($strSql)
    {
        $result = mysql_query($strSql);
        
            if(!$result)
            {
                throw new Exception(mysql_error());
            }else{
                return $result;
            }    
    }
    
    /**
     * Close Mysql Connection
     * @param type $identifier (optional)
     * @return boolean
     * @throws Exception
     */
    public function closeMySql($identifier = false)
    {
        $result = mysql_close($identifier);
        if(!$result)
            {
                throw new Exception(mysql_error());
            }else{
                return true;
            }   
    }
    
    /**
     * Create Database
     * @param string $strDatabaseName
     * @return string|false
     */
    public function addDatabase($strDatabaseName)
    {
        $sql = 'CREATE DATABASE ';
        return is_string($strDatabaseName)? $sql.= " '$strDatabaseName' ":false;   
    }
    
    /**
     * View all Tables from Database Name
     * @param string $strDatabaseName
     * @return string|false
     */
    public function viewTables($strDatabaseName)
    {
       $sql = 'SHOW TABLES FROM '; 
       return is_string($strDatabaseName)? $sql.= " '$strDatabaseName' ":false;
    }
    
    /**
     * View all Columns from Database Name
     * @param string $strDatabaseName
     * @return string|boolean
     */
    public function viewColumns($strDatabaseName)
    {
       $sql = 'SHOW COLUMNS FROM ';
       return is_string($strDatabaseName)? $sql.= " '$strDatabaseName' ":false;
    }
    
    /**
     * Remove Table from Database
     * @param string $strTableName
     * @return string|boolean
     */
    public function dropTable($strTableName)
    {
       $sql = 'DROP TABLE ';
       return is_string($strTableName)? $sql.= " '$strTableName' ":false;
    }
    
    /**
     * Remove all Items from TableName
     * @param string $strTableName
     * @return string|boolean
     */
    public function truncateTable($strTableName)
    {
       $sql = 'TRUNCATE TABLE ';
       return is_string($strTableName)? $sql.= " '$strTableName' ":false;
    }
    
    /**
     * bind with UNION Syntax 2 SQL Strings
     * @param string $strFirstSql
     * @param string $strSecondSql
     * @return string|boolean
     */
    public function bindSqlSyntax($strFirstSql,$strSecondSql)
    {
        return is_string($strFirstSql) && is_string($strSecondSql)? $strFirstSql.' UNION '.$strSecondSql:false;   
    }
    
    
    /**
     * Create Left Join SQL Statement
     * 
     * Example: selectLeftJoin(false,array(
     *               
     *              table1 => loginid,
     *              table2 => id            
     * 
     *          ),array(  // where clause
     *             
     *               table1.kartoffel => 20 
     *          ));
     * Result: SELECT * FROM table1 LEFT JOIN table2 ON table1.loginid = table2.id WHERE table1.kartoffel = 20
     *  
     * @param array $arySelectColumns (normal array)
     * @param array $aryLeftJoinTables (asso)
     * @param array $aryWhereClause (asso)
     * @param array $aryOrderBy (asso)
     * @param array $aryLimit (normal)
     * @param integer $intOperatorNumber
     * @return string | SQL Left Join Syntax
     */
    public function selectLeftJoin($arySelectColumns = false,$aryLeftJoinTables = false, $aryWhereClause = false,$aryOrderBy = false, $aryLimit = false, $intOperatorNumber = false)
    {
        
        if(is_array($arySelectColumns))
        {
            $this->moreSelectColumns($arySelectColumns);
            
        }else{
            
            $strSql = 'SELECT * FROM ';
            
        }
        
        
        if(is_array($aryLeftJoinTables) && count($aryLeftJoinTables) == self::two)
        {
            
            $saveFirstTable  = self::nothing;
            $saveSecondTable = self::nothing;
            
            $saveFirstColumn = self::nothing;
            $saveSecondColumn = self::nothing;
            
            $intCounter = self::one;
            
            foreach($aryLeftJoinTables as $strTable => $strColumn)
            {
                
                if($intCounter == self::one)
                {
                    $saveFirstTable = $strTable;
                    $saveFirstColumn = $strColumn;
                }
                
                if($intCounter == self::two)
                {
                    $saveSecondTable = $strTable;
                    $saveSecondColumn = $strColumn;
                }
               
                $intCounter++;
            }
            
            $strSql .= $saveFirstTable;
            $strSql .= ' LEFT JOIN ';
            $strSql .= $saveSecondTable;
            $strSql .= ' ON (';
            $strSql .= $saveFirstTable.'.'.$saveFirstColumn;
            $strSql .= " = ";
            $strSql .= $saveSecondTable.'.'.$saveSecondColumn;
            $strSql .= " ) ";
              
        }
        
        
        if(is_array($aryWhereClause)){
          $strSql .= $this->getWhereClause($aryWhereClause,$aryOrderBy,$aryLimit,$intOperatorNumber);
        }
        
      return $strSql;  
    }
    
    
    /**
     * Create Insert SQL Command from InsertData into TableName
     * Example: insertSqlData('table',array('columnUser' => 'username');
     * @param string $strTableName
     * @param array $aryInsertData
     * @return string|boolean
     */
    public function insertSqlData($strTableName,$aryInsertData)
    {
        
      if(is_string($strTableName) && is_array($aryInsertData))
      {
         $intInsertSize   = count($aryInsertData); 
         
         // Create SQL String
         $strSql          = 'INSERT INTO ';
         // add TableName to SQL String
         $strSql         .= " $strTableName (";
         
         $intArrayCounter  = self::one;     // set Counter Default (declare)
         $saveColumnString = self::nothing; // set ColumnString Default (declare)
         $saveCellString   = self::nothing; // set CellString Default  (declare)
         
         foreach($aryInsertData as $strColumnName => $strCellContent)
         {
              if($intArrayCounter != $intInsertSize){
                  
                  $saveColumnString .= " $strColumnName , ";
                  $saveCellString   .= is_string($strCellContent)? " '$strCellContent' , ": $strCellContent.' , ';
                  
              }else{
                  
                  $saveColumnString .= " $strColumnName ) ";
                  $saveCellString   .= is_string($strCellContent)? " '$strCellContent' ); ": $strCellContent.' ); ';
              }
              
            $intArrayCounter++; // intArrayCounter +1 
         }
         
         // add SQL String
         $strSql .= $saveColumnString.' VALUES( '.$saveCellString;
         return $strSql; 
      }
        
       return false;      
    }
    
    
    /**
     * Create Delete SQL Syntax
     * 
     * @param string $strTableName
     * @param array $aryWhereClause
     * @param integer $intOperatorNumber
     * @return string
     */
    public function deleteSqlData($strTableName,$aryWhereClause,$intOperatorNumber = false)
    {
        $strSql  = 'DELETE FROM ';
        $strSql .= " $strTableName ";
        
        if(is_array($aryWhereClause)){
          $strSql .= $this->getWhereClause($aryWhereClause,false,false,$intOperatorNumber);
        }
        
       return $strSql;        
    }
    
    /**
     * Create Select SQL Syntax
     * 
     * @param string $strTableName TableName
     * @param array $arySelectColumns (o)(normal Array)
     * @param array $aryWhereClause (o)(asso Array)
     * @param array $aryOrderBy (o)(asso Array) 
     * @param array $aryLimit (o)(normal Array) 
     * @param integer $intOperatorNumber (optional)
     * @return string
     */
    public function selectSqlData($strTableName,$arySelectColumns = false,$aryWhereClause = false, $aryOrderBy = false, $aryLimit = false,$intOperatorNumber = false)
    {
        
      $strSql = 'SELECT ';  
        
       if(is_array($arySelectColumns))
       {
          $intSelectColumnSize = count($arySelectColumns); 
          $intSelectColumnCounter = self::one;
          
           foreach($arySelectColumns as $strSelectColumns)
           {
              
               if($intSelectColumnSize == self::one)
               {
                    $strSql .= $strSelectColumns.' FROM ';
               }
               
               if($intSelectColumnSize > self::one)
               {
                   if($intSelectColumnCounter == $intSelectColumnSize)
                   {
                       $strSql .= $strSelectColumns.' FROM ';
                   }else{
                       
                       $strSql .= $strSelectColumns.' , ';  
                   }
                     
               }
               
             $intSelectColumnCounter++;
           }  
           
          $strSql .= " $strTableName "; 
           
       }else{
           $strSql .= '* FROM'." $strTableName ";
       }
       

       // Add Where,OrdyBy or AND Limit Clause
       $strSql .= $this->getWhereClause($aryWhereClause,$aryOrderBy,$aryLimit,$intOperatorNumber);
        
       return $strSql; 
    }
    
    
    /**
     * Create more Select Columns
     * Example: moreSelectColumns('table','tabl2');
     * Result:  SELECT table,tabl2 FROM ....
     * @param type $arySelectColumns
     * @return string
     */
    public function moreSelectColumns($arySelectColumns)
    { 
       if(is_array($arySelectColumns))
       {
          $strSql = ' SELECT ';
           
          $intSelectColumnSize = count($arySelectColumns); 
          $intSelectColumnCounter = self::one;
          
           foreach($arySelectColumns as $strSelectColumns)
           {
              
               if($intSelectColumnSize == self::one)
               {
                    $strSql .= $strSelectColumns.' FROM ';
               }
               
               if($intSelectColumnSize > self::one)
               {
                   if($intSelectColumnCounter == $intSelectColumnSize)
                   {
                       $strSql .= $strSelectColumns.' FROM ';
                   }else{
                       
                       $strSql .= $strSelectColumns.' , ';  
                   }
                     
               }
               
             $intSelectColumnCounter++;
           }  
            
          return $strSql;
       }
    }
    
    
    /**
     * Create Update SQL Syntax with WHERE clause
     * 
     * Example: updateSqlData('table',array('ColumnName' => 'huhu'),array('ColumnName' => 'ColumnContent'),false);
     * Example  Result:  UPDATE table SET ColumnName = huhu WHERE ColumnName = ColumnContent;
     * @param string $strTableName
     * @param array $aryUpdate
     * @param array $aryWhereClause
     * @param integer $intOperatorNumber (optional)
     * @return boolean|string
     */
    public function updateSqlData($strTableName,$aryUpdate,$aryWhereClause,$intOperatorNumber = false)
    {
         
        if(is_string($strTableName) && is_array($aryUpdate) && is_array($aryWhereClause))
        {
            $strSql  = 'UPDATE ';
            $strSql .= " $strTableName SET ";
            
            $intUpdateSize = count($aryUpdate);
            $intUpdateCounter = self::one;
             
              
                         foreach($aryUpdate as $strColumnName => $strColumnContent)
                         {
                                // is exists a one Update from Array.
                                if($intUpdateSize == self::one){
                                        $strSql .= " $strColumnName ";
                                        $strSql .= '=';
                                        $strSql .= " ".is_string($strColumnContent)? " '$strColumnContent' ": $strColumnContent.' ';
                                }
                                
                                // is exists more Updates from Array.
                                if($intUpdateSize > self::one){
                                    
                                    if($intUpdateCounter == $intUpdateSize){
                                        
                                        //Example: UPDATE Table SET ColumnName = ColumnContent, ColumnName = ColumnContent 
                                        //End Update without Komma
                                        $strSql .= " $strColumnName ";
                                        $strSql .= '=';
                                        $strSql .= " ".is_string($strColumnContent)? " '$strColumnContent' ": $strColumnContent.' ';
                                        
                                    }else{
                                        
                                        //Example: UPDATE Table SET ColumnName = ColumnContent, ColumnName = ColumnContent,
                                        //with Komma
                                        $strSql .= " $strColumnName ";
                                        $strSql .= '=';
                                        $strSql .= " ".is_string($strColumnContent)? " '$strColumnContent' , ": $strColumnContent.' , ';
                                        
                                    }
                                    
                                }
                                
                           $intUpdateCounter++;
                         }
                     
                // add Where Clause to SQL String     
               if(is_array($aryWhereClause)){ 
                   $strSql .= $this->getWhereClause($aryWhereClause,false,false,$intOperatorNumber);
               }
                  
            return $strSql;
        }
        
      return false;
    }
    
    
    
    /**
     * Create Orderby Claus for anything Methode
     * Example: getOrderBy(array('ColumnName => 'ASC') false) SQL = ORDER BY ColumnName ASC;
     * Example: getOrderBy(array('ColumnName => 'ASC') true)  SQL = ORDER BY ColumnName ASC
     * 
     * Example: getOrderBy(array('ColumnName => 'DESC') false) SQL = ORDER BY ColumnName DESC;
     * Example: getOrderBy(array('ColumnName => 'DESC') true)  SQL = ORDER BY ColumnName DESC
     * 
     * @param type $aryOrderByWithColumn
     * @param type $boolLimitArray
     * @return string|boolean
     */
    private function getOrderBy($aryOrderByWithColumn,$isLimit = false)
    {
        if(is_array($aryOrderByWithColumn))
        {
            $intOrderBySize    = count($aryOrderByWithColumn);
            $intOrderByCounter = self::one; 
            
            $strSql = ' ORDER BY ';
            
            foreach($aryOrderByWithColumn as $strColumnName => $strOrderBy)
            {
                if($intOrderBySize == self::one)
                {
                    $strSql .= " $strColumnName ";
                    $strSql .= $strOrderBy.($isLimit == true)? self::nothing :' ; ';    
                }
                
                if($intOrderBySize  > self::one){
                    
                    if($intOrderByCounter == $intOrderBySize){
                        
                        $strSql .= " $strColumnName ";
                        $strSql .= $strOrderBy.($isLimit == true)? self::nothing :' ; ';
                        
                    }else{
                        
                        $strSql .= " $strColumnName ";
                        $strSql .= $strOrderBy.' , '; 
                        
                    }
                    
                }
                
                
               $intOrderByCounter++; 
            }
            
          return $strSql;
            
        }
        
       return false; 
    }
    
    /**
     * Create Limit Clause for anything Methoden
     * SQL: LIMIT 0,1
     * @param integer $intFirstLimit
     * @param integer $intSecondLimit
     * @return string|boolean
     */
    private function getLimitClause($intFirstLimit,$intSecondLimit)
    {
        if(is_numeric($intFirstLimit) && is_numeric($intSecondLimit))
        {
            $strSql  = ' LIMIT ';
            $strSql .= $intFirstLimit.' , '.$intSecondLimit.' ; ';
            
            return $strSql;
        }
 
       return false;
    }
    
    /**
     * Create SQL Where Clause for anything Methoden 
     * Example with ALL:
     *         getWhereClause(array(   // WhereClause
     *             
     *             'ColumnName' => ColumnContent,
     *             'ColumnName' => ColumnContent    
     *             
     *          ),array(     //OrderBy Clause
     * 
     *            'ColumnName' => 'ASC',
     *          
     *          ),array( 0,1 ),0);
     *         Result: WHERE ColumnName = ColumnContent AND ColumnName = ColumnContent ORDER BY ColumnName = ASC LIMIT 0,1;
     * Example Operator: if operator Number 6. 
     *         Result: WHERE ColumnName = ColumnContent OR ColumnName = ColumnContent ORDER BY ColumnName = ASC LIMIT 0,1;
     * 
     * @param array $aryWhereClause
     * @param array $aryOrderBy (optional)
     * @param array $aryLimit (optional)
     * @param integer $intOperatorNumber (optional)
     * @return string
     */
    private function getWhereClause($aryWhereClause = false,$aryOrderBy = false,$aryLimit = false,$intOperatorNumber = false)
    {
        //set Default Operator by False: == 
        $strOperator = is_numeric($intOperatorNumber)? $this->getOperator($intOperatorNumber):$this->getOperator();
                
            if(is_array($aryWhereClause)){
          
                $intWhereSize  = count($aryWhereClause);
                $intWhereCounter  = self::one;
                
                $strSql = ' WHERE ';
                               
                    foreach($aryWhereClause as $strColumnName => $strColumnContent)
                    {
                       
                        if($intWhereSize == self::one)
                        {
                            $strSql .= " $strColumnName ";
                            $strSql .= ' = ';
                            $strSql .= is_string($strColumnContent)? " '$strColumnContent' ".(is_array($aryLimit)|| is_array($aryOrderBy)? self::nothing : ';') : " $strColumnContent " .(is_array($aryLimit)? self::nothing : ';');
                            
                        }
                        
                        if($intWhereSize > self::one){
                            
                            if($intWhereCounter == $intWhereSize){
                                
                                $strSql .= " $strColumnName ";
                                $strSql .= ' = ';
                                $strSql .= is_string($strColumnContent)? " '$strColumnContent' ".(is_array($aryLimit)|| is_array($aryOrderBy)? self::nothing : ';') : " $strColumnContent " .(is_array($aryLimit)? self::nothing : ';');
                                
                            }else{
                                
                                $strSql .= " $strColumnName ";
                                $strSql .= ' = ';
                                $strSql .= is_string($strColumnContent)? " '$strColumnContent' $strOperator ": " $strColumnContent "." $strOperator ";  
                            }   
                        }
                        
                        
                       $intWhereCounter++; 
                    }
                    
                 // add OrderBy 
                 if(is_array($aryOrderBy)){
                    
                    $strSql .= $this->getOrderBy($aryOrderBy, is_array($aryLimit)? true:false);
                    
                 } 
                    
                 // add Limit 
                if(is_array($aryLimit)){
                    
                    $strSql .= $this->getLimitClause($aryLimit[0], $aryLimit[1]);
                    
                }    
                    
                
               return $strSql;
          
            } 
            
            if(is_array($aryOrderBy) || is_array($aryLimit))
            {
                
                // add OrderBy 
                 if(is_array($aryOrderBy)){
                    
                    $strSql .= $this->getOrderBy($aryOrderBy, is_array($aryLimit)? true:false);
                    
                 } 
                    
                 // add Limit 
                if(is_array($aryLimit)){
                    
                    $strSql .= $this->getLimitClause($aryLimit[0], $aryLimit[1]);
                    
                } 
                
                
                return $strSql;
            }  
            
            
              
       return self::nothing;
    }
    
    
    /**
     * Return Operator String for Example: WhereClause
     * @param integer $intCounter
     * @return string
     */
    private function getOperator($intCounter = 0)
    {
        $aryOperatoren = array(
           'AND',
           '>=',
           '<=',
           '!=',
           '==',
           '=',
           'OR'
        );
        
        $aryOperatorenSize = count($aryOperatoren);
        
        // set Default Operator
        if($aryOperatorenSize > $intCounter)
        {
            return $aryOperatoren[0];
        }
        
      return $aryOperatoren[$intCounter]; 
    }
    

    
    
    
    
    
}





