<?php

class SoapServerCustomerPortal {

    protected static $boolDebug = false;
    private static $aryClass = array();
    private static $strPhpWsdlFile = null;
    private static $strPhpWsdlCache = null;

    public function __construct($debug = false) {
        if (self::$boolDebug == false && $debug != false)
            self::$boolDebug = true;
    }

    public static function getDebug() {
        return self::$boolDebug;
    }

    public static function setClass($aryClassFiles) {
        if (is_array($aryClassFiles)) {
            foreach ($aryClassFiles as $strFileName) {
                require_once($strFileName);
            }
        }

        self::$aryClass = $aryClassFiles;
    }

    public static function getClassFiles() {
        return self::$aryClass;
    }

    public static function setPhpWsdlFile($strPhpWsdlFile) {
        if (self::$strPhpWsdlFile == null) {
            self::$strPhpWsdlFile = $strPhpWsdlFile;
        }
    }

    public static function getPhpWsdlFile() {
        return self::$strPhpWsdlFile;
    }

    public static function setPhpWsdlCacheDirectory($strDirectory) {
        if (self::$strPhpWsdlCache == null) {
            self::$strPhpWsdlCache = $strDirectory;
        }
    }

    public static function getPhpWsdlCacheDirectory() {
        return self::$strPhpWsdlCache;
    }

    public static function CreateSoapServer($strPhpWsdlFile = false, $aryClassFiles = false) {
        self::setPhpWsdlCacheDirectory('./wsdl/cache');

        self::setPhpWsdlFile('./wsdl/class.phpwsdl.php');
        $phpWsdlFle = self::getPhpWsdlFile();

        self::setClass(array(
            'class.mysql.php'
        ));
        $classFiles = self::getClassFiles();

        if ($strPhpWsdlFile != false) {
            $phpWsdlFle = $strPhpWsdlFile;
        }

        if (is_array($aryClassFiles)) {
            $classFiles = $aryClassFiles;
        }

        // Initialize the PhpWsdl class
        require_once($phpWsdlFle);

        $soapServer = PhpWsdl::CreateInstance(
                        null, // PhpWsdl will determine a good namespace
                        null, // Change this to your SOAP endpoint URI (or keep it NULL and PhpWsdl will determine it)
                        self::getPhpWsdlCacheDirectory(), // Change this to a folder with write access
                        $classFiles, null, // The name of the class that serves the webservice will be determined by PhpWsdl
                        null, // This demo contains all method definitions in comments
                        null, // This demo contains all complex types in comments
                        false, // Don't send WSDL right now
                        false);

        return $soapServer;
    }

    public function RunServer($objSoapServer) {
        // Disable caching for demonstration
        ini_set('soap.wsdl_cache_enabled', 0); // Disable caching in PHP
        PhpWsdl::$CacheTime = 0;     // Disable caching in PhpWsdl
        $objSoapServer->ForceOutputWsdl = false;

        if (self::getDebug()) {
            PhpWsdl::$Debugging = true;
            PhpWsdl::$DebugFile = './wsdl/cache/debug.log';
            PhpWsdl::$DebugBackTrace = true;
        }

        // Run the SOAP server
        if ($objSoapServer->IsWsdlRequested())   // WSDL requested by the client?
            $objSoapServer->Optimize = true;    // Don't optimize WSDL to send it human readable to the browser
            
//$soap->ParseDocs=false;				// Uncomment this line to disable the whole documentation features
        //$soap->IncludeDocs=false;				// Uncomment this line to disable writing the documentation in WSDL XML
        //$wsdl=$soap->CreateWsdl();                               // This would save the WSDL XML string in $wsdl
        //$php=$soap->OutputPhp(false,false);	// This would save a PHP SOAP client as PHP source code string in $php
        //$html=$soap->OutputHtml(false,false);	// This would save the HTML documentation string in $html

        $objSoapServer->RunServer();
    }

}

$soap = new SoapServerCustomerPortal(false);
$server = $soap->CreateSoapServer();
$soap->RunServer($server);