<?php
/**
 *  Ajax Controller 
 */
class AjaxHandleController extends Controller
{
    private static $objModelListe = null;
    private static $objAjaxAction = null;
        
    public function __construct() {
        parent::__construct();
        
        self::$objAjaxAction = Factory::getFactory( 'ajaxAction' ); 
        self::$objModelListe = array(
            
            'moveItem',
            'sellItems',
            'modifyItem',
            'itemInfo',
            'viewCart',
            'buyItems',
            'removeItems',
            'mergeItems'
        );
        self::$objAjaxAction->addModel(self::$objModelListe); 
    }
    
    public function main()
    {
       //Default Methode  
    }
    
    
    public function mergeItems()
    {
        if(self::$objAjaxAction->mergeItems()){
            
            self::$objAjaxAction->Show('ajax/message.tpl'); //sell Message
            
        }else{
            self::$objAjaxAction->Show('error.tpl');
        }
    }
    
    
    public function removeItems()
    {
       if(self::$objAjaxAction->ajaxRemoveItem()){
            
            self::$objAjaxAction->Show('ajax/message.tpl');
            
        }else{
            self::$objAjaxAction->Show('error.tpl');
        }  
    }
    
    /**
     *  Move Items
     */
    public function moveItem()
    {
       if(self::$objAjaxAction->ajaxMoveItem()){
            
            self::$objAjaxAction->Show('ajax/message.tpl'); //sell Message
            
        }else{
            self::$objAjaxAction->Show('error.tpl');
        }
    }
    
    
    public function selectSell()
    {
       if(self::$objAjaxAction->ajaxSelectSellItems()){
            
            self::$objAjaxAction->Show('ajax/message.tpl'); // sell Message
            
        }else{
            self::$objAjaxAction->Show('error.tpl');
        } 
        
    }
    
    /**
     *  Sell Items 
     */
    public function sellItem()
    {
        if(self::$objAjaxAction->ajaxSellItems()){
            
            self::$objAjaxAction->Show('ajax/message.tpl'); //sell Message
            
        }else{
            self::$objAjaxAction->Show('error.tpl');
        }
    }
    
    /**
     *  Change Money Stats from Item
     *  Double Zahlen saved er noch nicht...
     */
    public function saveSellingItems()
    {
       if(self::$objAjaxAction->ajaxSaveItemPrice()){
           
           self::$objAjaxAction->Show('ajax/selling.tpl');
           
       }else{
           self::$objAjaxAction->Show('error.tpl');
       }
    }
    
    /**
     *  Show Item Details for Selling.
     */
    public function showItemSell()
    {
       if(self::$objAjaxAction->ajaxDisplaySellBox()){
             
            self::$objAjaxAction->Show('ajax/selling.tpl');
           
       }else{
            self::$objAjaxAction->Show('error.tpl');
       }
    }
    

    /**
     *  Show Item Details 
     */
    public function showInfo()
    {
        if(self::$objAjaxAction->ajaxItemDetailsInformation()){
             
            self::$objAjaxAction->Show('ajax/iteminfov3.tpl');
           
       }else{
            self::$objAjaxAction->Show('error.tpl');
       }
    }
    
    
    /**
     * Clear Warenkorb
     */
    public function clearCartList()
    {
        $ajaxModel = $this->loadModel('ajax');
        $aryItemsApsId = $ajaxModel->getCAPTA('ids');
        
        if(empty($aryItemsApsId)){
            
            /* Clear complete */
            $ss = new Session(); 
            $ss->createSession('cart_session', array());
            $this->showCart();
            
        }else{
           if(isset($_SESSION['cart_session'])){
            foreach($_SESSION['cart_session'] as $key => $aidnumber){
                
                if($aidnumber == $aryItemsApsId[0]){
                    unset($_SESSION['cart_session'][$key]);
                }
            }
           }
        }
    }
    
    /**
     *  Show Shopping Cart 
     */
    public function showCart()
    {
       if(self::$objAjaxAction->ajaxViewCartBox()){
             
            self::$objAjaxAction->Show('ajax/cart.tpl');
           
       }else{
            
            self::$objAjaxAction->Show('error.tpl');
       }
    }
    
    
    /**
     *  Show Cart Details 
     */
    public function showCartDetails()
    {
        if(self::$objAjaxAction->ajaxViewCartDetails()){
             
            self::$objAjaxAction->Show('ajax/cartdetails.tpl');
           
       }else{
            self::$objAjaxAction->Show('error.tpl');
       }
    }

    
    /**
     *  Show Gift Box 
     */
    public function showGiftBox()
    {
        // loading Ajax Model 
//        $ajaxModel = $this->loadModel('ajax');
//        $aryItemsApsId = $ajaxModel->getCAPTA('ids');
//        
//        // size Items
//        $intApsSize = count($aryItemsApsId);
//        
//        // get more Item Infomations
//        $selectItem   = $this->loadModel('ItemInfo');
        
        // comming soon...... 
        $this->getViewer()->display('ajax/giftbox.tpl');   
    }
    
    /**
     *  Ajax Buy Methode 
     */
    public function buyItem()
    {
       if(self::$objAjaxAction->ajaxBuyAction()){
             
            self::$objAjaxAction->Show('ajax/message.tpl');
           
       }else{
            self::$objAjaxAction->Show('error.tpl');
       }
   
    }
    
    
   
}
