<?php
/** 
 * The Main Controller by Mutzii
 * @author Mutzii  <black.mutzi@googlemail.com>
 * @category Controller
 * @version 0.0.5
 * @copyright  Copyright (c) 2012-2013 by Mutzii
 */ 
abstract class Controller
{
   use AutoLoader; 
   
   protected static $objViewer   = null; 
   protected static $dbgTimer    = null;
   protected static $objSecurity = null;
   private   static $dbgInfos     = null;
   
   private static $strGetController = null;
   private static $strGetMethode    = null;  
   
   const CONTROLLER = 'Controller';
   const NOTHING = "";
   const EMPTY_STRING = "";
   const AUCTIONS_HOUSE = "index";
   const AUCTION = "auction";
   const POSTBOX = "postbox";
   const STOREHOUSE = "storehouse";
     
    public function __construct() { }
    abstract public function main();
        
    // Controller Initialzed
    public static function initialized()
    {
         session_start();
        
         self::$dbgTimer = microtime(true);
         self::Debug('Timer Start..');
         self::initClasses();
         self::initViewerSetup();
         self::setControllerViewerAssign();
         self::loadingTemplateConfig();
         
         
                    try{
                                 // Player Session
                                 $objSession  = new Session(false); 
                                 if(!isset($_SESSION['player'])){ 
                                     $objSession->createSession('player', false);
                                 }else{
                                     self::$objViewer->assign('header_player',self::getLoginPlayer()); 
                                 }

                                //* Read Config 
                                $objConfigReader = new ConfigReader(AHROOT.'/config/config.inc.php');
                                $currentConfig   = $objConfigReader->getConfigArray();
                                
                                //* Default: ?module=
                                self::$strGetController = $currentConfig['controller']['get']['controller'];
                                //* Default: ?action=
                                self::$strGetMethode = $currentConfig['controller']['get']['methode'];
                                

                                 //Navigations PlaceHolders
                                 $objNavigation = self::loadModel('Navigation');
                                 $aryNaviPlaceHolder = $objNavigation->getMenuPlaceHolder();

                                 
                                 foreach($aryNaviPlaceHolder as $info)
                                 {
                                     self::getViewer()->assign($info['navName'],$info['en']);
                                 }
                                
                                 // Create Controller Filter
                                 $objControllerFilter = new ControllerFilter(array(
                                    'plugins/',
                                    '' //controllers directory
                                 )); self::Debug('Done with Controller Filter.');
                                
                                 //Go to Login Controller 
                                 if($objSession->getSession('player') == false){ 
                                     
                                     $_GET[self::$strGetController] = $currentConfig['controller']['login']['default'];
                                     $_GET[self::$strGetMethode]    = $currentConfig['controller']['action']['default'];
                                 }
                                 
                                 //Default Controller 
                                 if(!isset($_GET[self::$strGetController]) || empty($_GET[self::$strGetController])){  
                                     
                                     $_GET[self::$strGetController] = $currentConfig['controller']['controller']['default'];
                                     $_GET[self::$strGetMethode]    = $currentConfig['controller']['action']['default'];
                                     
                                 }
                                
                                             while(true)
                                             {
                                                //Loading Controller
                                                if(isset($_GET[self::$strGetController]) && !empty($_GET[self::$strGetController])){

                                                    //Search Controller
                                                    if($objControllerFilter::searchController($_GET[self::$strGetController])) // include Controller
                                                    {
                                                        $strControllerClassName = ucfirst($_GET[self::$strGetController]).self::CONTROLLER;

                                                                if(class_exists($strControllerClassName)){

                                                                        $objController = new $strControllerClassName(); // init Controller

                                                                        if(isset($_GET[self::$strGetMethode])){

                                                                            if(method_exists( $objController , $_GET[self::$strGetMethode] )){

                                                                                    $objController->$_GET[self::$strGetMethode](); // Start Controller...                                                     
                                                                                    break; //break While 
                                                                            }else{
                                                                                    self::Call('404',$currentConfig);                                                
                                                                            }
                                                                        }else{
                                                                                // Default Methode 
                                                                                $_GET[self::$strGetMethode]  = $currentConfig['controller']['action']['default'];  
                                                                        }

                                                                }else{
                                                                     self::Call('404',$currentConfig);
                                                                } 

                                                        }else{
                                                             self::Call('404',$currentConfig);                        
                                                        }
                                                    }

                                                 }//while(true)
                                 
                        
                    }catch(Exception $e){
                            // Show General Exceptions
                            echo $e->getMessage();
                    }
      
        } // End initialized Methode
    
    
      
    /**
     *  Loading Template Config 
     */
    public static function loadingTemplateConfig()
    {
        $objConfigReader = new ConfigReader(AHROOT.'/config/config.inc.php');
        $currentConfig   = $objConfigReader->getConfigArray();
        
        //* Template Config
        self::$objViewer->assign('css',$currentConfig['template']['css']);
        self::$objViewer->assign('js',$currentConfig['template']['js']);
        self::$objViewer->assign('images',$currentConfig['template']['images']);
        
    }
        
    /**
     * Call 404 Pages
     * @param string $strControllerName
     * @param array $currentConfig
     */
    public static function Call($strControllerName, $currentConfig)
    {
        if($strControllerName == '404')
        {
            $_GET[self::$strGetController] = 'error';
            $_GET[self::$strGetMethode]    = $currentConfig['controller']['action']['default'];   
        }
    }
    
    /**
     *  Initialized Template Engine
     */
    public static function initViewerSetup()
    {
        try{
             
             ViewerSetup::setTemplateDirectorys(array(
                ''      
             ));
             
             self::$objViewer = ViewerSetup::getInstance();
           
         }catch(Exception $e){
             die($e->getMessage());
         } 
    }
    
    /**
     *  set Controller Template Assigns
     */
    public static function setControllerViewerAssign()
    {
        if(is_object(self::$objViewer)){
         
              //* Current MVC Version
              self::$objViewer->assign('version',VERSION);
              
              //* Menue Links
              self::$objViewer->assign('actionindex','?module=homepage');
              self::$objViewer->assign('action','?module=homepage&action=navi');
              self::$objViewer->assign('actionlogout','?module=login&action=logout');
              self::$objViewer->assign('actionfeedback','?module=homepage&action=feedback');
              self::$objViewer->assign('actionadmin','?module=admin');
              self::$objViewer->assign('actionprofil','?module=profil'); 
              
              
              //* Player
              $objPlayer = new Player();
              
              if($objPlayer->isPlayerOnline()){
                self::$objViewer->assign('playername',self::getLoginPlayer());
                self::$objViewer->assign('playermoney',$objPlayer->getPlayerMoney(self::getLoginPlayer()));
              }
        }
    }
    
    /**
     *  Initialized Class Files
     */
    public static function initClasses()
    {
               
        self::loadingClasses('/classes/class.exception.php');
        self::loadingClasses('/classes/class.security.php');
        self::loadingClasses('/classes/class.session.php');
        self::loadingClasses('/classes/class.controllerfilter.php');
        self::loadingClasses('/classes/mysql/class.mysql.php');
        self::loadingClasses('/classes/class.configreader.php');
        self::loadingClasses('/classes/class.dbtables.php');
        self::loadingClasses('/classes/class.useragent.php');
        self::loadingClasses('/classes/class.api.php');
        self::loadingClasses('/classes/class.model.php');
        self::loadingClasses('/classes/class.progressbar.php');
        self::loadingClasses('/classes/class.factory.php');
        self::loadingClasses('/libs/viewer/viewer.php');
        self::loadingClasses('/classes/class.singleViewer.php');
        self::loadingClasses('/classes/interfaces/interface.const.php');
        self::loadingClasses('/classes/api/class.collectItems.php');
        self::loadingClasses('/classes/api/class.permission.php');
        self::loadingClasses('/classes/api/class.player.php');
        self::loadingClasses('/classes/database/class.enchantment.php');
        self::loadingClasses('/classes/database/class.itemDetails.php');
        self::loadingClasses('/classes/database/class.items.php');
        self::loadingClasses('/libs/dbug/dbug.php');
    }
    
    
    /**
     * Loading Class Files
     * @param string $strPathName
     */
    public static function loadingClasses($strPathName)
    {
       require_once AHROOT.$strPathName; 
    }
    
    /**
     * Create Security String 
     * @param string $strRequest
     * @return string
     */
    public static function setSecurityString($strRequest)
    {
      self::$objSecurity->setType($strRequest);
      return self::$objSecurity->getString();
    }
    
    /**
     * Create Security Integer
     * @param integer $strRequest
     * @return integer
     */ 
    public static function setSecurityInteger($strRequest)
    {
      self::$objSecurity->setType($strRequest);
      return self::$objSecurity->getInteger();
    }
    
    
    /**
     * add Debug Text
     * @param string $strDebugInformation
     */
    public static function Debug($strDebugInformation)
    {
         $time_end = microtime(true);
         $currentTimer = $time_end - self::$dbgTimer;
         $time = number_format($currentTimer,4,',','.');
         self::$dbgInfos .= 'Timer: '.$time.' '.$strDebugInformation.' <br> ';  
    }
    
    /**
     * getViewer (Template Engine) Instance
     * @return object||boolean
     */
    public static function getViewer()
    {
       return is_object(self::$objViewer) ? is_string(self::$objViewer) ? null : self::$objViewer : null;
    }
    
    
    /**
     *  User Logout
     */
    public static function LogOut()
    {
       $session = new Session();
       
        if($session->getSessionId() != $session::nothing){
            $session->removeAllSessions();
            $session->sessionDestroy();
        }  
    }
    
     /**
     * get PlayerName from LoginUser
     * @return string 
     */
    public static function getLoginPlayer()
    {
        $objPlayerModel = self::loadModel('playerModel');
        return $objPlayerModel->getLoginPlayerName();
    }
	
    /**
     * Compare $strFirst with $strSecond
     * Is Strings equal return true else false
     * @param string $strFirst  
     * @param string $strSecond
     * @return boolean
     */
    public function strCompare($strFirst,$strSecond)
    {
        if(is_string($strFirst) && is_string($strSecond))
        {
            if(strcmp($strFirst,$strSecond) == false){
                  return true;
            }
            
        }
        
       return false;
    }
    

        
}// End the Controller Class 

?>

 
