<?php

class HomepageController extends Controller
{
    private static $objOptionsModel = null;
    private static $objHomeModel    = null;
    
    public function __construct() {
        parent::__construct();
        self::$objOptionsModel = parent::loadModel('options');
        self::$objHomeModel    = parent::loadModel('home');
        
    }
       
    public function main() 
    {
         // Create Profil Session
         $ss = new Session();
         $ss->createSession('profilAction', 'index');
         self::$objOptionsModel->createHomeOptions();
         $this->getViewer()->assign('profil_overview','Auctions House');         
         $this->setPlaceHolders(self::$objHomeModel->getAuctionsItemsAll()); 
         $this->getViewer()->homeLayout('index.tpl');   
    }
    
       
    public function navi()
    {
              $ss = new Session();     
              $intNavigationsNr = self::EMPTY_STRING;
            
              if(!isset($_GET['nav']) || empty($_GET['nav']))
              {
                 $intNavigationsNr = false;
              }else{
                 $intNavigationsNr = $_GET['nav'];
              }
                  
                    switch($ss->getSession('profilAction'))
                    {
                        case self::AUCTIONS_HOUSE:
                              self::$objOptionsModel->createHomeOptions();
                              $this->getViewer()->assign('profil_overview','Auctions House');
                              $this->setPlaceHolders(self::$objHomeModel->getAuctionsItemsAll($intNavigationsNr,$aryLimit = false));
                              $this->getViewer()->homeLayout('index.tpl');  
                        break;
                        case self::AUCTION: 
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                            
                              $this->setPlaceHolders(self::$objHomeModel->getAuctionsItems($this->getLoginPlayer(),$intNavigationsNr));
                              $this->getViewer()->assign('profil_overview','Your Auctions');
                              $this->getViewer()->homeLayout('module/profil/auctions.tpl'); 
                        break;
                        case self::POSTBOX:
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                              
                              $this->setPlaceHolders(self::$objHomeModel->getPostBoxItems($this->getLoginPlayer(),$intNavigationsNr));
                              $this->getViewer()->assign('profil_overview','Your PostBox');
                              $this->getViewer()->homeLayout('module/profil/postbox.tpl'); 
                        break;
                        case self::STOREHOUSE:
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                              
                              $this->setPlaceHolders(self::$objHomeModel->getStoreHouseItems($this->getLoginPlayer(),$intNavigationsNr));
                              $this->getViewer()->assign('profil_overview','Your Storehouse');
                              $this->getViewer()->homeLayout('module/profil/storehouse.tpl');
                        break;
                    }          
    }
    
    
    /**
     *  Item Search 
     */
    public function search()
    {
        if(isset($_GET['byName']) || !empty($_GET['byName']))
        {
             $ss = new Session(); 
             $strSearchName = $_GET['byName']; 
             
                switch($ss->getSession('profilAction'))
                    {
                        case self::AUCTIONS_HOUSE:
                              self::$objOptionsModel->createHomeOptions();
                                                          
                              $this->getViewer()->assign('profil_overview','Auctions House');
                              $this->setPlaceHolders(self::$objHomeModel->getAuctionsItemsWithSearchIndex($strSearchName, false));
                              $this->getViewer()->homeLayout('index.tpl');  
                        break;
                        case self::AUCTION:
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                              
                              $this->setPlaceHolders(self::$objHomeModel->getAuctionsItemsWithPlayerAndSearchIndex($this->getLoginPlayer(),$strSearchName,false));
                              $this->getViewer()->assign('profil_overview','Your Auctions');
                              $this->getViewer()->homeLayout('module/profil/auctions.tpl'); 
                        break;
                        case self::POSTBOX:
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                              
                              $this->setPlaceHolders(self::$objHomeModel->getPostBoxItemsWithPlayerAndSearchIndex($this->getLoginPlayer(),$strSearchName,false));
                              $this->getViewer()->assign('profil_overview','Your PostBox');
                              $this->getViewer()->homeLayout('module/profil/postbox.tpl'); 
                        break;
                        case self::STOREHOUSE:
                              self::$objOptionsModel->createHomeOptions();
                            
                              $objFeatures = parent::loadModel('features');
                              $strFeatures = $objFeatures->createFeatureButtons();
                              $this->getViewer()->assign('features',$strFeatures);
                              
                              $this->setPlaceHolders(self::$objHomeModel->getStoreHouseItemsWithPlayerAndSearchIndex($this->getLoginPlayer(),$strSearchName,false));
                              $this->getViewer()->assign('profil_overview','Your Storehouse');
                              $this->getViewer()->homeLayout('module/profil/storehouse.tpl');
                        break;
                    } 
            
        }else{
            $this->index();
        }  
    }
    
    
    /**
     * set PlaceHolders from Item List or Navigations List..
     * @param array $aryItems
     */
    private function setPlaceHolders($aryItems)
    {
        if(is_array($aryItems)){
            
            foreach($aryItems as $strPlaceHolder => $strContent)
            {
               $this->getViewer()->assign($strPlaceHolder,$strContent);             
            }   
        }
    }
    
    
    
    
    
    
    
}