<?php

class ProfilController extends Controller {
    
    const SCROLL_DOWN = FALSE;
    
    public function __construct() {
        parent::__construct();
    }
    
    
    /**
     *  Profil Default Index
     */
    public function main() 
    {
       $this->getViewer()->assign('profil_overview','Profil Overview');
       $this->getViewer()->homeLayout('module/profil/overview.tpl'); 
    }
    
    
    /**
     * View All Auction Items from LoginPlayer
     * @param array $aryLimit
     */
    public function auction()
    {
        // Create Profil Session
        $ss = new Session();
        $ss->createSession('profilAction', 'auction');
                
        $objHomeModel = $this->loadModel('home');
        $objOptionsModel = $this->loadModel('options');
         
        $strTopOptions   = $objOptionsModel->createSelectAction();
        $strDownOptions  = $objOptionsModel->createSelectAction(array(
            'o_scroll' => self::SCROLL_DOWN
        ));
        
        $aryItems = $objHomeModel->getAuctionsItems($this->getLoginPlayer());
        
        $this->loadingItemsPlaceHolder($aryItems);
        
        $entryOptions = $objOptionsModel->createEntryOptions();
         
        $objFeatures = parent::loadModel('features');
        $strFeatures = $objFeatures->createFeatureButtons();
        
        $this->getViewer()->assign('features',$strFeatures);
        $this->getViewer()->assign('home_options_entry',$entryOptions);
        $this->getViewer()->assign('home_options_top',$strTopOptions);
        $this->getViewer()->assign('home_options_down',$strDownOptions);
        $this->getViewer()->assign('profil_overview','Your Auctions');
        $this->getViewer()->homeLayout('module/profil/auctions.tpl'); 
    }
    
    
    /**
     * View All Postbox Items from LoginPlayer
     * @param array $aryLimit
     */
    public function postbox()
    {
        // Create Profil Session
        $ss = new Session();
        $ss->createSession('profilAction', 'postbox');
        
        $objHomeModel = $this->loadModel('home');
        $objOptionsModel = $this->loadModel('options');
        $strTopOptions   = $objOptionsModel->createSelectAction();
        $strDownOptions  = $objOptionsModel->createSelectAction(array(
            'o_scroll' => self::SCROLL_DOWN
        ));
        
        $objFeatures = parent::loadModel('features');
        $strFeatures = $objFeatures->createFeatureButtons();
        
        $aryItems = $objHomeModel->getPostBoxItems($this->getLoginPlayer());
        $this->loadingItemsPlaceHolder($aryItems); 
        $entryOptions = $objOptionsModel->createEntryOptions();
         
        $this->getViewer()->assign('features',$strFeatures);
        $this->getViewer()->assign('home_options_entry',$entryOptions);
        $this->getViewer()->assign('home_options_top',$strTopOptions);
        $this->getViewer()->assign('home_options_down',$strDownOptions);
        $this->getViewer()->assign('profil_overview','Your PostBox');
        $this->getViewer()->homeLayout('module/profil/postbox.tpl'); 
    }
    
    
    /**
     * View All StoreHouse Items from LoginPlayer
     * @param array $aryLimit
     */
    public function storehouse()
    {
        // Create Profil Session
        $ss = new Session();
        $ss->createSession('profilAction', 'storehouse');
        
        $objHomeModel = $this->loadModel('home');
        $objOptionsModel = $this->loadModel('options');
        $strTopOptions   = $objOptionsModel->createSelectAction(false);
        $strDownOptions  = $objOptionsModel->createSelectAction(array(
            'o_scroll' => self::SCROLL_DOWN
        ));
        $aryItems = $objHomeModel->getStoreHouseItems($this->getLoginPlayer());
        $this->loadingItemsPlaceHolder($aryItems); 
        
        $entryOptions = $objOptionsModel->createEntryOptions();
         
        $objFeatures = parent::loadModel('features');
        $strFeatures = $objFeatures->createFeatureButtons();
        
        $this->getViewer()->assign('features',$strFeatures);
        $this->getViewer()->assign('home_options_entry',$entryOptions);
        $this->getViewer()->assign('home_options_top',$strTopOptions);
        $this->getViewer()->assign('home_options_down',$strDownOptions);
        $this->getViewer()->assign('profil_overview','Your Storehouse');
        $this->getViewer()->homeLayout('module/profil/storehouse.tpl');  
    }
    
    
    /**
     *  Change Player Password 
     */
    public function password()
    {
        $objProfilModel = $this->loadModel('profil');
        
        if(isset($_POST['password']) && !empty($_POST['password']))
        {
            $objProfilModel->userChangePassword($_POST['password']);
            $this->getViewer()->homeLayout('module/profil/viewPasswordChange.tpl'); 
            
        }else{
            
            $this->getViewer()->homeLayout('module/profil/viewPassword.tpl');  
        }
    }
    
    
    
    /**
     * Write Template Placeholder
     * @param array $aryItems
     */
    private function loadingItemsPlaceHolder($aryItems)
    {
               
        if(is_array($aryItems)){
            
            foreach($aryItems as $strPlaceHolder => $strContent)
            {
               $this->getViewer()->assign($strPlaceHolder,$strContent);             
            }   
        }
       
    }
    
    
    
    
 
}

?>
