<?php

class UpdateController extends Controller {
    
    private static $objUpdateModel = null;
    private static $objProgressBar = null;
     
    public function __construct() {
        parent::__construct();
    }
    
    public function main()
    {
         $objPlayerModel = parent::loadModel('playerModel');
         
         if($objPlayerModel->isPlayerPermission('Administrator'))
         {
             $this->update();
         }
         
    }
    
    
    public function update()
    {
        self::$objUpdateModel = parent::loadModel('update');
        self::$objProgressBar = new Progressbar(0, $this->getDirectoryCount(), 500, 40);
        
        echo "
            
            <html>
                <head>
                    <title>AuctionsHouse Update </title>
                </head>
                    <body>
                        <p>".self::$objProgressBar->print_code()."</p>
                

             ";     
        
                    $this->scanDirectory(AHROOT);
        
        echo "</body>
            </html>
        ";
           
    }
    
    
    
    /**
     * return size of Directorys
     * @return integer
     */
    public function getDirectoryCount()
    {
       $intCounter = 3; //Optimiert
        
        if(is_dir(AHROOT))
        {
           $dirHandle = opendir(AHROOT);
                while($dirContent = readdir($dirHandle))
                 {
                   if ($dirContent != "." && $dirContent != "..") {
                     if(is_dir($dirContent)){
                        $intCounter++;
                     }
                   }
                 }
            closedir($dirHandle);
        } 
        
      return $intCounter;
    }
    
    /**
     * File Hash 
     * @param string $strFileName
     * @return string
     */
    public function getFileHash( $strFileName )
    {
        if(is_file($strFileName))
             return hash_file('md5', $strFileName); 
    }
    
    /**
     * Update Files 
     * @param string $strDirectoryName
     * @return boolean
     */
    public function scanDirectory($strDirectoryName)
    {  
       if(strcmp(AHROOT,$strDirectoryName) == false){  
                     self::$objProgressBar->_echo('Initialized Update ... <br>');
                     $this->scanNewFiles($strDirectoryName);
        } 
        
        if(is_dir($strDirectoryName))
        {
            $dirHandle = opendir($strDirectoryName);
            
                 while($dirContent = readdir($dirHandle))
                 {
                   if ($dirContent != "." && $dirContent != "..") {
                                            
                             if(is_dir($strDirectoryName.'/'.$dirContent))
                             {
                                  //self::$objProgressBar->_echo('Check Directory:'.$dirContent.'<br>');
                                 $directoryPath = $strDirectoryName.'/'.$dirContent;
                                 
                                 $this->scanNewFiles($directoryPath);
                                 $this->scanDirectory($directoryPath);
                             }

                             if(is_file($strDirectoryName.'/'.$dirContent)){
                                 
                                 $strFilePath = $strDirectoryName.'/'.$dirContent;
                                 $strCurrentHashFile = $this->getFileHash($strDirectoryName.'/'.$dirContent);
                                                                  
                                 $aryFileInfos = self::$objUpdateModel->getFileInfo($dirContent);
                                                                  
                                   if(strcmp($aryFileInfos['hash'],$strCurrentHashFile) != false)
                                    {   
                                       
                                       $strCurrentFilePath = str_replace(AHROOT,'', $strFilePath);
                                       
                                       if(strcmp($aryFileInfos['path'],$strCurrentFilePath) == false)
                                       {
                                           
                                          if(file_exists($strFilePath)){
                                             self::$objProgressBar->_echo('Update File:'.$strCurrentFilePath.'<br>');
                                             $fileContent = base64_decode(self::$objUpdateModel->downloadFile($aryFileInfos['path']));
                                             file_put_contents($strFilePath, $fileContent); //create new File
                                          }   
                                           
                                           
                                       }
                                       
                                    } 
                             } 

                   }
                  if(strcmp(AHROOT,$strDirectoryName) == false){  
                     self::$objProgressBar->step();
                  }
                 }
                 
             closedir($dirHandle);
              
        }
        
                 if(strcmp(AHROOT,$strDirectoryName) == false){  
                     self::$objProgressBar->complete();
                     self::$objProgressBar->_echo('Done! ... <br>');
                  }
        
        return false;
    }
    
    
    
    
    
    
    public function scanNewFiles( $strDirectoryName )
    {
        $aryLocalDirectoryList = $this->getDirectoryContent( $strDirectoryName );
        
        $soapDirectoryName = str_replace(AHROOT,'', $strDirectoryName);
        $arySoapDirectoryList  = self::$objUpdateModel->getDirectoryContent( $soapDirectoryName );
        
        $aryDiffDirectoryContent = array_diff($arySoapDirectoryList, $aryLocalDirectoryList);
                
        foreach($aryDiffDirectoryContent as $directoryContent)
        {
                      
                    if(strpos($directoryContent, '.') === false){
                       if(!file_exists($strDirectoryName.'/'.$directoryContent))
                       {
                           mkdir($strDirectoryName.'/'.$directoryContent);
                           self::$objProgressBar->_echo('Create Directroy :'.$strDirectoryName.'/'.$directoryContent.'<br>');
                           
                           if(substr(sprintf('%o', fileperms($strDirectoryName.'/'.$directoryContent)), -4) != 0777){

                                chmod($strDirectoryName.'/'.$directoryContent, 0777);
                           }

                           continue;
                       }
                     }
                
           
                   if(!file_exists($strDirectoryName.'/'.$directoryContent))
                   {
                       file_put_contents($strDirectoryName.'/'.$directoryContent, " "); 
                       self::$objProgressBar->_echo('Create File :'.$strDirectoryName.'/'.$directoryContent.'<br>');
                       if(substr(sprintf('%o', fileperms($strDirectoryName.'/'.$directoryContent)), -4) != 0777){

                            chmod($strDirectoryName.'/'.$directoryContent, 0777);
                       }

                       continue;
                   }
        }
        
      
       return true;
    }
    
    

    public function getDirectoryContent( $strDirectoryName )
    {
        $localDirectoryContent = array();
        
        if(is_dir($strDirectoryName))
        {
            $dirHandle = opendir($strDirectoryName);
           
                while($dirContent = readdir($dirHandle)){
                    
                    if ($dirContent != "." && $dirContent != "..") {
                        array_push($localDirectoryContent,$dirContent);  
                    }
                   
                }
        }
        
       return $localDirectoryContent;  
    }
    
    
    
    
    
    
    
      
   
}

?>
