<?php

/** 
 * Template Engine Viewer by Mutzii
 * @author Mutzii  <black.mutzi@googlemail.com>
 * @category Engine
 * @version 0.1
 * @copyright  Copyright (c) 2012-2013 by Mutzii
 */
class Viewer
{
  use AutoLoader;  
  const nothing = "";  
  
  private static $strMasterTemplateDirectory = '/view/templates/';
  private static $templateDirectorys  = array(); 
  private static $templatePlaceHolder = array();
  private static $templateContent     = self::nothing;
  
    protected function __construct( $aryTemplateDirectorys ){
        
        $this->setTemplateDirectorys($aryTemplateDirectorys);
    }
    
     /**
     * set Array Filter
     * @param type $templateDirectorys (normal Array)
     */
    private static function setTemplateDirectorys( $templateDirectorys )
    {
        self::$templateDirectorys = $templateDirectorys;
    }
    
    /**
     * get Array Filter
     * @return array (normal Array)
     */
    private static function getTemplateDirectorys()
    {
       return is_array(self::$templateDirectorys)? self::$templateDirectorys : false;
    }
    
    
    /**
     * Read Template and Write Content into $templateContent
     * @param string $templatePath
     */
    private static function readTemplate( $templatePath ) 
    {
        if(is_string($templatePath) && file_exists($templatePath))
        {
            $fileOpen = fopen($templatePath,"r");
            $content  = self::nothing;
            
		   while(!feof($fileOpen))
                    {  
			$temp = fgets($fileOpen);
			//self::$templateContent .= $temp;
                        $content .= $temp;
		    } 
                    
           return $content;
        }
    }
    
    /**
     * get Template Content 
     * @return string Template Content
     */
    private static function getTemplateContent()
    {
        return self::$templateContent;
    }
    
    /**
     * get PlaceHolder asso Array
     * @return array
     */
    private static function getPlaceHolder()
    {
        return self::$templatePlaceHolder;
    }
    
    /**
     * Replace PlaceHolder String from Template
     * @param string $strContent (tpl content)
     * @param array $aryPlaceHolder (asso array)
     */
    private static function replacePlaceHolder( $strContent, $aryPlaceHolder )
    {
        /*Replace PlaceHolder {example} */
        if(is_array($aryPlaceHolder)){
		  
	      foreach($aryPlaceHolder as $strPlaceHolder => $strPlaceHolderValue){ 
	         $strContent = str_replace($strPlaceHolder,$strPlaceHolderValue,$strContent);
              }
        }
        
        
        
        
        /*Example: {assign value='inhalt'}*/
        if(preg_match("#\{assign (.*?)='(.*?)'\}#",$strContent,$treffer,PREG_OFFSET_CAPTURE)){
            
            $typeName  = $treffer[1][0];
            $typeInput = $treffer[2][0];
           
            self::assign($typeName, $typeInput);
            $strContent = preg_replace("#\{assign $typeName='$typeInput'\}#","", $strContent);
            $strContent = self::replacePlaceHolder($strContent, self::getPlaceHolder());
            unset($treffer); 
            
        }
        
        /*include Templates {include=templatename}*/
        if(preg_match_all("#\{include=(.*?)\}#",$strContent,$treffer,PREG_OFFSET_CAPTURE)){
            
            foreach($treffer[1] as $aryFileName){
                
                $fileName = $aryFileName[0];
                $templatePath = self::searchTemplate( $fileName );
                    if($templatePath != false){
            
                         $content      = self::readTemplate($templatePath);
                         $content      = self::replacePlaceHolder($content, self::getPlaceHolder());

                         $strContent = preg_replace("#\{include=$fileName\}#", $content, $strContent);
                    }
            
            }                              
        }
        
        /* Translate Label */
        if(preg_match("#\{translate=(.*?)\}#",$strContent,$treffer,PREG_OFFSET_CAPTURE)){
            
            $strLabelName = $treffer[1][0];
            
            $objTranslate = self::loadModel("translate");
            $content = $objTranslate->getTranslateLabel( $strLabelName );
            
            $strContent = preg_replace("#\{translate=$strLabelName\}#", $content, $strContent);
            $strContent = self::replacePlaceHolder($strContent, self::getPlaceHolder());
            unset($treffer);
        }
        
        
        /* if  <-- noch nicht ausgereift...*/
        if(preg_match("#\{if (.*?)=(.*?)\} (.*?) {/if}#",$strContent,$treffer,PREG_OFFSET_CAPTURE)){
            
            $firstString  = $treffer[1][0];
            $secondString = $treffer[2][0];
            
            $explode = explode('{else}', $treffer[3][0]);
            
           
            if(count($explode) > 1){
                         
                  $trueContent  = $explode[0];
                  $falseContent = $explode[1];
                  
                  if(strcmp($firstString,$secondString) == false){
                        //true
                        $strContent = preg_replace("#\{if $firstString=$secondString\} (.*?) {/if}#", $trueContent, $strContent);  
                  }else{
                       //false
                        $strContent = preg_replace("#\{if $firstString=$secondString\} (.*?) {/if}#", $falseContent, $strContent);  
                  }
                  
               
            }else{
                
                  $content = $explode[0]; 
                  
                  if(strcmp($firstString,$secondString) == false){
                        //true
                        $strContent = preg_replace("#\{if $firstString=$secondString\} (.*?) {/if}#", $content, $strContent);  
                  }else{
                       //false
                        $strContent = preg_replace("#\{if $firstString=$secondString\} (.*?) {/if}#", "", $strContent);  
                  }
                  
            }
            
            unset($treffer);
        }
        
        
        
        
        
       
        return $strContent;
    }
    
    /**
     * Create or Set Placeholder Asso Array
     * @param array $aryFill (asso array)
     */
    private static function fillPlaceHolder( $aryFill )
    {
        if(is_array($aryFill))
        {
            self::$templatePlaceHolder = array_merge(self::$templatePlaceHolder,$aryFill);   
        }   
    }
    
    /**
     * Search Controller Name in the Directorys and Include this
     * @param string  $templateName
     * @return boolean found:true 
     */
    private static function searchTemplate( $templateName )
    {
       $templatePath = null;
       
       if(is_array(self::$templateDirectorys) && count(self::$templateDirectorys) != null){
            
            foreach(self::$templateDirectorys as $strFilterContent)
            {
                if(is_string($strFilterContent) && is_string($templateName))
                { 
                   $target = AHROOT. self::$strMasterTemplateDirectory . $strFilterContent . $templateName. ''; 
                   if(file_exists($target)){
                       $templatePath = $target;
                       break;
                   }
                }
            }
            
        }
         
      return is_null($templatePath)? false : $templatePath;
    }
    
    /**
     * set Template PlaceHolder 
     * @param string $strVariable placeholder String 
     * @param string|int|array $mixContent placeholder content
     */
    public static function assign( $strVariable , $mixContent)
    {
       if(is_string($strVariable))
       {
           self::fillPlaceHolder(array(
               '{'.$strVariable.'}' => is_bool($mixContent) ||  is_object($mixContent)? self::nothing : $mixContent
           ));  
       }  
    }
    
    /**
     * get Template Content 
     * @param string $templateName
     * @throws string Template not found
     */
    public function display( $templateName )
    {
       $templatePath = $this->searchTemplate( $templateName );
       
       if($templatePath != false)
       {
           $content = $this->readTemplate($templatePath);
           $content = $this->replacePlaceHolder($content, $this->getPlaceHolder());
           echo $content; //$this->getTemplateContent();
           
       }else{
          throw new Exception('Template '.$templateName.' not found. :(');   
       }
    }
    
    /**
     * get Template Content 
     * @param string  $templateName
     * @return string TemplateContent 
     * @throws string Template not Found
     */
    public function getTemplateAsString( $templateName )
    {
       $templatePath = $this->searchTemplate( $templateName );
       
       if($templatePath != false)
       {
           $content = $this->readTemplate($templatePath);
           $content = $this->replacePlaceHolder($content,$this->getPlaceHolder());
           return  $content;
       }else{
          throw new Exception('Template '.$templateName.' not found. :(');   
       }  
    }
    
}



?>
