<?php

/**
 *  Item Info Class get Minecraft Item Informations
 */
class ItemInfo extends Model
{
    protected static $tblLang  = array(); 
    protected static $tblItems  = array(); 
    
    private static $prefixInfo = 'info_';
    
    public function __construct() {
        parent::__construct();
        
        self::$tblLang = $this->getLangTables();
        self::$tblItems = $this->getItemTables();
           
    }
    
    public function ajaxItemDetailsInformation()
    {
        //get Aucions || PostBox or StoreHouse ID
        $databaseId = $_GET['ajaxItemId'];        
        //Mode 
        $ajaxMode = $_GET['ajaxMode'];
        
        // get more Item Infomations
        $selectItem   = $this->loadModel('ItemInfo');
        
        if($selectItem->isExistsDatabaseId($databaseId))
        {
                $aryItemInfo  = $selectItem->getItemInfo($databaseId);
                
                // Item Name
                $strItemName   = $selectItem->getItemName($databaseId);

                // Item Path 
                $itemPath = $selectItem->getItemPath($databaseId);

                // set Placeholders
                $this->getAjaxAssign(self::$prefixInfo.'itemid',$aryItemInfo['itemId']);
                $this->getAjaxAssign(self::$prefixInfo.'itemBytes',$aryItemInfo['itemBytes']);
                $this->getAjaxAssign(self::$prefixInfo.'itemStack',$aryItemInfo['itemStack']);
                $this->getAjaxAssign(self::$prefixInfo.'itemPrice',$aryItemInfo['itemPrice']);
                $this->getAjaxAssign(self::$prefixInfo.'enchName',$aryItemInfo['enchName']);
                $this->getAjaxAssign(self::$prefixInfo.'enchLevel',$aryItemInfo['enchLevel']);
                $this->getAjaxAssign(self::$prefixInfo.'itemName',$strItemName);
                $this->getAjaxAssign(self::$prefixInfo.'itemPath',$itemPath);
                
                $singlePrice       = $aryItemInfo['itemPrice'] / $aryItemInfo['itemStack'];
                $singleprice       = number_format($singlePrice,2,',','.');
                
                $this->getAjaxAssign(self::$prefixInfo.'singleItemPrice',$singlePrice);
                
                
                $objPlayer = new Player();
                $session   = new Session();
                
                $tblChanger     = $this->loadmodel('selecttable');
                $intTableNumber = $tblChanger->getTableNumber($session->getSession('profilAction'));
                
                if($intTableNumber == self::TABLE_INDEX){
                    $intTableNumber = self::TABLE_AUCTION;
                }
               
                $playerId       = $objPlayer->getPlayerIdfromItem($databaseId,$intTableNumber);
                
                $strPlayerName = $objPlayer->getPlayerName($playerId);
                $this->getAjaxAssign(self::$prefixInfo.'itemOwner',$strPlayerName);
                
                                
                $objItemStatsModel = $this->loadModel('itemStats');
                
                $intBuyShowPercent    = $objItemStatsModel->getItemBuyPercent( $strItemName );
                $intSellShowPercent   = $objItemStatsModel->getItemSellPercent( $strItemName );
                
                
                $objStatsFactoryBuy = Factory::getFactory('itemStatistic');
                $objStatsFactoryBuy->setDivBoxName('item_stats');
                $objStatsFactoryBuy->setStatisticConfig($intBuyShowPercent, '178', '16', '00FF00', '11');
  
                $buyStats = $objStatsFactoryBuy->Show();

                
                $objStatsFactorySell = Factory::getFactory('itemStatistic');
                $objStatsFactorySell->setDivBoxName('item_stats');
                $objStatsFactorySell->setStatisticConfig($intSellShowPercent, '178', '16', '00FF00', '11');
                
                $sellStats = $objStatsFactorySell->Show();
                
                //set Database Item ID
                $this->getAjaxAssign(self::$prefixInfo.'itemDatabaseId',$databaseId);
                
                /*v1.0.3*/
                $this->getAjaxAssign('info_total_buy', $buyStats);
                $this->getAjaxAssign('info_total_sold', $sellStats);
                
                /*-----*/
            
                        // Show  Default ItemInfo
                        if(!isset($_GET['ajaxMode'])){
                            
                                    $this->getAjaxAssign('more_item_information',$this->getAjaxViewer()->getTemplateAsString('ajax/iteminfo/default.tpl'));
                        }else{
                            
                            switch($ajaxMode)
                            {
                                case 'ench':
                                    $this->getAjaxAssign('more_item_information',$this->getAjaxViewer()->getTemplateAsString('ajax/iteminfo/enchantments.tpl'));
                                break;
                                case 'stats':
                                    $this->getAjaxAssign('info_total_buy', $buyStats);
                                    $this->getAjaxAssign('info_total_sold', $sellStats);
                                    $this->getAjaxAssign('more_item_information',$this->getAjaxViewer()->getTemplateAsString('ajax/iteminfo/stats.tpl'));
                                break; 
                                default:
                                    $this->getAjaxAssign('more_item_information',$this->getAjaxViewer()->getTemplateAsString('ajax/iteminfo/default.tpl'));
                                break;
                            }
                            
                        }
                
                return true;
        }else{
            
            $this->getAjaxAssign('error', $databaseId);
        }
    
       return false;
    }
    
    
    
    /**
     * @param integer $aid
     * @param string $strPlayerName
     * @return boolean
     */
    public function existsAidbyPlayer( $aid , $strPlayerName)
    {
        $player = new Player();
        $playerId = $player->getPlayerId($strPlayerName);
        
        $ss = new Session();
        $tblChanger   = $this->loadmodel('selecttable');
        $strTableName = $tblChanger->profilItemTablesviaName($ss->getSession('profilAction'));
                     
        $strSql = $this->selectSqlData($strTableName,array('id'), array(
           
            'id' => $aid,
            'playerId' => $playerId
            
        )); $itemTableBoxResult = $this->getMysqlQuery($strSql);
        

        $currentAid = null;
        
        while($daten = mysql_fetch_array($itemTableBoxResult)){
              $currentAid = $daten['id'];
              break;
        }
                
        if(is_numeric($currentAid)){
            return true;
        }else{
            return false;
        }
         
    }
    
    public function isExistsAID($aid, $intTableNumber)
    {
        $objSelectTableModel = $this->loadModel('selecttable');
        $selectTable = $objSelectTableModel->profilItemTablesviaId($intTableNumber);

        
        $strSql = $this->selectSqlData($selectTable, array('playerId'), array(
           
            'id' => $aid
            
        )); $itemTableResult = $this->getMysqlQuery($strSql);
        
        
        $intCounter = 0;
                
                while($daten = mysql_fetch_assoc($itemTableResult))
                {
                   $intCounter++;
                }
                
                 // If exists the ID then is $intCounter = 1
                if($intCounter == self::one)
                {
                    return true;
                }
        
                
      return false;
    }
    
    
    /**
     * Exists the Database ID ? If yes return true.
     * @param integer $itemIdentificationsNumber
     * @return boolean
     */
    public function isExistsDatabaseId($itemIdentificationsNumber)
    {
       if(is_numeric($itemIdentificationsNumber))
       {
                    
              $strSql = $this->selectSqlData(self::$tblItems['it'],false, array(
                  'id' => $itemIdentificationsNumber
              ));  
              
                $result = $this->getMysqlQuery($strSql);
                $intCounter = 0;
                
                while($daten = mysql_fetch_assoc($result))
                {
                   $intCounter++;
                }
                
                // If exists the ID then is $intCounter = 1
                if($intCounter == self::one)
                {
                    return true;
                }
                
                // If exists the ID more as one then is a Database Error.
                if($intCounter > self::one)
                {
                    return false;
                }
                
              
       }
       
      return false; 
    }
    
    /**
     * Read the Table ah_items and write from the DatabaseItemId Infomations
     * into a new Array.
     * Example Output: array[columname]
     * @param integer $itemIdentificationsNumbers = DatabaseId
     * @return array
     */
    public function getItemInfo($itemIdentificationsNumber)
    {
        if(is_numeric($itemIdentificationsNumber))
        {
            return parent::$objAuctionsAPI->getItemInfo($itemIdentificationsNumber);
        }
        
      return false;
    }
    
    /**
     * AID Liste
     * @param string  $strPlayerName
     * @param integer $intFromTable
     * @return array
     */
    public function getItemIdListe( $strPlayerName , $intFromTable)
    {
       $player = new Player();
       return $player->getPlayerItemList( $strPlayerName , $intFromTable );
    }
    
    
    /**
     * 
     * @param string $strItemName
     * @return string
     */
    public function getItemPathViaItemName( $strItemName )
    {
        $intItemLanguageId = self::EMPTY_STRING; 
        $strItemPath       = self::EMPTY_STRING;
        
        $strSql = $this->selectSqlData(self::$tblLang['lang_items'], array('id'), array(
            'en' => $strItemName
        )); $langItemsResult = $this->getMysqlQuery($strSql);

        while($daten = mysql_fetch_array($langItemsResult)){
            
           $intItemLanguageId = $daten['id'];
            break;
        }
        
        $strSql = $this->selectSqlData(self::$tblItems['it_icons'], array('itemPath'), array(
           
            'itemLanguageId' => $intItemLanguageId
            
        )); $itemIconsResult = $this->getMysqlQuery($strSql);        
        
        while($daten = mysql_fetch_array($itemIconsResult)){
            
            $strItemPath = $daten['itemPath'];
            
            break;
        }
        
     return $strItemPath; 
    }
    
    /**
     * get Item ID from Item Namen 
     * @param string $strItemName
     * @return integer
     */
    public function getItemId( $strItemName )
    {
         $strSql = $this->selectSqlData(self::$tblLang['lang_items'], array('id'), array(
            'en' => $strItemName
        )); $langItemsResult = $this->getMysqlQuery($strSql);

        while($daten = mysql_fetch_array($langItemsResult)){
            
           $intItemLanguageId = $daten['id'];
            break;
        }
        
         $strSql = $this->selectSqlData(self::$tblItems['it_icons'], array('itemId'), array(
           
            'itemLanguageId' => $intItemLanguageId
            
        )); $itemIconsResult = $this->getMysqlQuery($strSql);        
        
        while($daten = mysql_fetch_array($itemIconsResult)){
            
            $intItemId = $daten['itemId'];
            
            break;
        }
        
       return $intItemId;
    }
    
    
    public function getItemBytes( $strItemName )
    {
         $strSql = $this->selectSqlData(self::$tblLang['lang_items'], array('id'), array(
            'en' => $strItemName
        )); $langItemsResult = $this->getMysqlQuery($strSql);

        while($daten = mysql_fetch_array($langItemsResult)){
            
           $intItemLanguageId = $daten['id'];
            break;
        }
        
         $strSql = $this->selectSqlData(self::$tblItems['it_icons'], array('itemBytes'), array(
           
            'itemLanguageId' => $intItemLanguageId
            
        )); $itemIconsResult = $this->getMysqlQuery($strSql);        
        
        while($daten = mysql_fetch_array($itemIconsResult)){
            
            $intItemBytes = $daten['itemBytes'];
            
            break;
        }
        
       return $intItemBytes;
    }
    
    /**
     * Read the ah_items_icons Table and get via Bytes and Ids the Item Image Path.
     * @param integer $intItemId
     * @param integer $intItemByte (default=0)
     * @param integer $intSecondItemByte (default=0)
     * @return string
     */
    public function getItemPath( $intItemAID )
    {
        return parent::$objAuctionsAPI->getItemPicturePath( $intItemAID );  
    }
    
    
    public function getItemNameLanguageId($itemLanguageId,$languageShortCut = 'en')
    {
        return parent::$objAuctionsAPI->getItemName($itemLanguageId,$languageShortCut);
    }
    
    
    /**
     * get Item Name
     * @param integer $intItemAID
     * @return string 
     */
    public function getItemName( $intItemAID )
    {
       $itemLanguageId = parent::$objAuctionsAPI->getItemLanguageId( $intItemAID );
       return parent::$objAuctionsAPI->getItemName($itemLanguageId,'en');
    }
    
    
}// class end


?>
