<?php

class ItemStats extends Model
{
    private static $tblItems = array();
    private static $objItemInfoModel = null;
    
    
    public function __construct() {
        parent::__construct();
        self::$tblItems = $this->getItemTables();
        self::$objItemInfoModel = $this->loadModel('itemInfo');
    }
    
    /**
     * Die Anzahl aller gekauften Items mit dem gleichen Item Namen als Prozent.
     * @param string $strItemName
     * @return integer
     */
    public function getItemBuyPercent( $strItemName ){
        
        $intAllLogBuyItems = $this->getItemAllBuySize();
        $intLogBuyItems    = $this->getItemBuySize( $strItemName );
        
        if($intAllLogBuyItems != 0){
             $calc = 100 / $intAllLogBuyItems;
        }
        
        return ($intAllLogBuyItems != 0)? round($calc) * $intLogBuyItems: 0;
    }
    
    /**
     * Die Anzahl aller verkauften Items mit dem gleichen Item Namen als Prozent.
     * @param string $strItemName
     * @return integer
     */
    public function getItemSellPercent( $strItemName ){
        
        $intAllLogSellItems = $this->getItemAllSellSize();
        $intLogSellItems    = $this->getItemSellSize( $strItemName );  
        
        if($intAllLogSellItems != 0){
           $calc = 100 / $intAllLogSellItems;
        }
        
        return ($intAllLogSellItems != 0)? round($calc) * $intLogSellItems : 0;
    }
    
    /**
     * Die Anzahl aller gekauften Items mit dem gleichen Item Namen
     * @param string $strItemName
     * @return integer
     */
    public function getItemBuySize( $strItemName )
    {        
        $intItemId = self::$objItemInfoModel->getItemId( $strItemName );
        $intItemBytes = self::$objItemInfoModel->getItemBytes( $strItemName );
        
        $strSql = $this->selectSqlData(self::$tblItems['it_log'], false, array(
           
            'itemId' => $intItemId,
            'itemBytes' => $intItemBytes,
            'logActionId' => 1 
            
        )); $logResult = $this->getMysqlQuery($strSql);
        
        $intItemCounter = self::_NULL;
        
        while($daten = mysql_fetch_array($logResult)){    
            $intItemCounter++;
        }
        
      return $intItemCounter;
    }
    
    /**
     * Die Anzahl aller verkauften Items mit dem gleichen Item Namen
     * @param string $strItemName
     * @return integer
     */
    public function getItemSellSize( $strItemName )
    {        
        $intItemId = self::$objItemInfoModel->getItemId( $strItemName );
        $intItemBytes = self::$objItemInfoModel->getItemBytes( $strItemName );
        
        $strSql = $this->selectSqlData(self::$tblItems['it_log'], false, array(
           
            'itemId' => $intItemId,
            'itemBytes' => $intItemBytes,
            'logActionId' => 2 
            
        )); $logResult = $this->getMysqlQuery($strSql);
        
        $intItemCounter = self::_NULL;
        
        while($daten = mysql_fetch_array($logResult)){    
            $intItemCounter++;
        }
        
      return $intItemCounter;
    }
    
    /**
     * Die Anzahl aller gekauften Items.
     * @return integer
     */
    public function getItemAllBuySize()
    {        

        $strSql = $this->selectSqlData(self::$tblItems['it_log'], false, array(
     
            'logActionId' => 1 
            
        )); $logResult = $this->getMysqlQuery($strSql);
        
        $intItemCounter = self::_NULL;
        
        while($daten = mysql_fetch_array($logResult)){    
            $intItemCounter++;
        }
        
      return $intItemCounter;
    }
    
    /**
     * Die Anzahl aller verkauften Items.
     * @return integer
     */
    public function getItemAllSellSize()
    {
        
        $strSql = $this->selectSqlData(self::$tblItems['it_log'], false, array(
           
            'logActionId' => 2 
            
        )); $logResult = $this->getMysqlQuery($strSql);
        
        $intItemCounter = self::_NULL;
        
        while($daten = mysql_fetch_array($logResult)){    
            $intItemCounter++;
        }
        
      return $intItemCounter;
    }
            
    
}