<?php

class MergeItems extends Model
{
    public function __construct() {
        parent::__construct();
    }
    
    private static $itemDeleteList = array();
    private static $itemFilter = array();
    private static $itemModifyFilter = array();
    private static $debuginfos = array();
    private static $itemInfo = null;
    
    
    const MAX_ITEM_STACK_SIZE = 64;
    
    
    /**
     * Merge Items 
     * @return boolean
     * @throws GlobalException
     */
    public function mergeItems()
    {       
        $objModifiyModel  = $this->loadmodel('modifyItem');
        $objRemoveItem    = $this->loadmodel('removeItems');
        self::$itemInfo   = $this->loadmodel('itemInfo');
        
        $objFactory = Factory::getFactory('message');  
       
              // For Items: not Stackable (another Items or Speziell Items)
              $this->setItemFilter(array(
                 
                  
              ));
            
            
              $aryEditItems  = $this->editItemInformations();
              $aryDeleteList = $this->getItemDeleteListe();
              $aryModifyList = $this->getItemModifyListe();
              
              foreach($aryEditItems as $aryAidListe)
              {
                try{  
                         $boolItemModify = false;
                         $boolItemRemove = false;
                         
                         $intAID    = $this->getItemAid($aryAidListe);
                         $itemInfo  = $this->getItemInfo($aryAidListe);

                         //Change Item Stack Size 
                         foreach($aryModifyList as $intSecondAID){
                             
                            if($this->isEqualAID($intAID, $intSecondAID)){  
                                $objModifiyModel->changeItemStack($intAID,$itemInfo['itemStack']);
                                $boolItemModify = true;
                            }
                            
                                 //Remove Item 
                                 foreach($aryDeleteList as $intSecondAID){
                                    if($this->isEqualAID($intAID, $intSecondAID)){  
                                        $objRemoveItem->removeItem($intAID);
                                        $boolItemRemove = true;
                                    }
                                 }
                                 
                                 if($boolItemModify){
                                     
                                         //Create Message
                                         $exception = new GlobalException('MoveInfo',0,null);
                                         $exception->setArray(array(

                                            'error' => 0,
                                            'info'  => array(
                                                     'aid'    =>  $intAID,
                                                     'remove' =>  $boolItemRemove,
                                                     'stack'  =>  $itemInfo['itemStack'],
                                                     'mode'   =>  1
                                                     )

                                           )); throw $exception; 
                                           
                                   $boolItemModify = false;
                                   $boolItemRemove = false;
                                 }
  
                         }
                         
                  }catch(GlobalException $e){
                    $objFactory->addInformations($e->getArray());    
                  }
                  
              }
                   
         $createMessage = $objFactory->Show(); 
         $this->getAjaxAssign('block_information', 'Merge Informations');
         $this->getAjaxAssign('message',$createMessage);
         return true;
    
    }
    
    
    /**
     * Main Methode from Merge Items Model 
     * Modify Items 
     * @return array
     */
    private function editItemInformations()
    {
        $aryAidListeWithItemInformations = $this->getItemInformations();
        $intFoundItemsSize = count($aryAidListeWithItemInformations);
        
        $counter = 0;
        
        while($counter < $intFoundItemsSize){
                            
            $intAID    = $this->getItemAid($aryAidListeWithItemInformations[$counter]);
            $itemInfo  = $this->getItemInfo($aryAidListeWithItemInformations[$counter]);
            
            /*Update:: Items with maxStackSize from One -> go to Filter */
            $aryItemInfo = self::$itemInfo->getItemInfo($intAID);
                if($aryItemInfo['maxStackSize'] == 1){
                    $this->addItemToFilter($intAID);
                }
            /*--- Update ---*/
            
            
                for($searchItem = 0; $searchItem < $intFoundItemsSize; $searchItem++)
                {
                        $intSecondAID   = $this->getItemAid($aryAidListeWithItemInformations[$searchItem]);
                        $secondItemInfo = $this->getItemInfo($aryAidListeWithItemInformations[$searchItem]);

                        /* Wenn die AIDs nicht Identisch sind, soll die Bearbeitung fortfahren */
                        if(!$this->isEqualAID($intAID, $intSecondAID)){
                            /* Wenn die AID bereits nicht auf der Delete List ist soll die Bearbeitung fortfahren*/
                            if(!$this->checkDeleteFilter($intAID) && !$this->checkDeleteFilter( $intSecondAID) ){
                                /* Wenn die Master AID nicht im Filter ist soll die Bearbeitung fortfahren */
                                if(!$this->checkItemFilter( $intAID ) && !$this->checkItemFilter( $intSecondAID )){
                                    /* Wenn der Item Stack nicht Full ist soll die Bearbeitung fortfahren */
                                    if(!$this->isItemStackFull($itemInfo)){
                                        /* Die bearbeitung soll fortfahren, wenn die Items gleicher Art sind */
                                        if($this->itemEquals($itemInfo,$secondItemInfo)){
                                        
                                                $intFailStackSize = $this->failStackSize($itemInfo);
                                                
                                                switch($this->nextItemMoreStackSize($intFailStackSize, $secondItemInfo))
                                                {
                                                    case 0: // Second Item Stack is little
                                                           
                                                           $this->setDebugInfo('MODE: --DELETE--');
                                                        
                                                           
                                                           $this->setDebugInfo('AID ('.$intAID .'): Current Stack Size:'.$this->getItemStack($itemInfo));
                                                           $this->setDebugInfo('Second AID ('.$intSecondAID.'): Current Stack Size:'.$this->getItemStack($secondItemInfo));
                                                        
                                                           $intSecondItemStack = $this->getItemStack($secondItemInfo);
                                                           $itemInfo = $this->addItemStack($itemInfo, $intSecondItemStack );
                                                           $this->deleteItem( $intSecondAID );
                                                           
                                                           if($this->isItemStackFull($itemInfo)){
                                                                $this->addItemToFilter( $intAID );
                                                                $this->setDebugInfo('Stack Size is FULL from ID:'.$intAID);
                                                                
                                                           }
                                                            $this->setDebugInfo('AID:'.$intAID.' :: ADD ItemStackSize '.$intSecondItemStack );
                                                            $this->setDebugInfo('Delete Second AID :'.$intSecondAID.' with old StackSize:'.$intSecondItemStack);
                                                            
                                                            $aryAidListeWithItemInformations[$counter][$intAID] = $itemInfo;
                                                                                                                       
                                                         
                                     
                                                            
                                                    break;
                                                    
                                                    case 1: // Second Stack is to Big 
                                                           
                                                            $this->setDebugInfo('MODE: --MODIFY--');
                                                           
                                                        
                                                            $this->setDebugInfo('AID ('.$intAID .'): Current Stack Size:'.$this->getItemStack($itemInfo));
                                                            $this->setDebugInfo('Second AID ('.$intSecondAID.'): Current Stack Size:'.$this->getItemStack($secondItemInfo));
                                                        
                                                           // add Master Stack Size the fail Stack Size 
                                                           $itemInfo = $this->addItemStack($itemInfo, $intFailStackSize );
                                                           // sub Second Stack
                                                           $secondItemInfo = $this->subItemStack($secondItemInfo, $intFailStackSize);
                                                        
                                                           if($this->isItemStackFull($itemInfo)){
                                                                $this->addItemToFilter( $intAID );
                                                                $this->setDebugInfo('Stack Size is FULL from ID:'.$intAID);
                                                           }
                                                           
                                                           
                                                           $this->setDebugInfo('MODIFIY AID:'.$intAID.' :: new ItemStack: '.$itemInfo['itemStack']);
                                                           $this->setDebugInfo('MODIFIY Second AID:'.$intSecondAID.' :: new ItemStack: '.$secondItemInfo['itemStack']);  
                                                                            
                                                           $aryAidListeWithItemInformations[$counter][$intAID] = $itemInfo;
                                                           $aryAidListeWithItemInformations[$searchItem][$intSecondAID] = $secondItemInfo;
                                                           
                                                    break;
   
                                                }
                                        
                                               // add Item to ModifyListe  
                                               $this->addItemModifyListe( $intAID );
                                               $this->addItemModifyListe( $intSecondAID );   
                                                   
                                          
                                       }
                                    }
                                }
                            }
                        }
                }   
 
          $counter++;          
        }
        
       return $aryAidListeWithItemInformations;  
    }
    

    /**
     *  Show Debug Info 
     */
    private function ShowDebugInfo()
    {
       $strInfos = self::EMPTY_STRING; 
        
        foreach(self::$debuginfos as $strInfo)
        {
            $strInfos .= $strInfo;
        }
        
      return $strInfos; 
    }
    
    private function setDebugInfo( $strInformation )
    {
        array_push(self::$debuginfos, $strInformation.'<br>');
    }
    
    /**
     * has next Item More or equal Stack Size 
     * @param integer $intFailStackSize
     * @param array $aryItemInfo
     * @return boolean
     */
    private function nextItemMoreStackSize($intFailStackSize, $aryItemInfo)
    {
        if($aryItemInfo['itemStack'] >  $intFailStackSize)
        {
            return 1;
        }
         
        if($aryItemInfo['itemStack'] <= $intFailStackSize){
            
            return 0; 
        }

    }
    
    /**
     * Fehlender Stack Size 
     * @param array $aryItemInfo
     * @return integer
     */
    private function failStackSize( $aryItemInfo )
    {
      return self::MAX_ITEM_STACK_SIZE - $aryItemInfo['itemStack'];   
    }
    
    
    /**
     * is Item Stack Full
     * @param array $aryItemInfo
     * @return boolean
     */
    private function isItemStackFull( $aryItemInfo )
    {
        if($aryItemInfo['itemStack'] == self::MAX_ITEM_STACK_SIZE)
            return true;
       return false;
    }
    
    /**
     * Equal AIDs
     * @param integer $intFirstAID
     * @param integer $intSecondAID
     * @return boolean
     */
    private function isEqualAID($intFirstAID,$intSecondAID)
    {
        if($intFirstAID == $intSecondAID)
             return true; 
            
      return false;
    }
    
    /**
     * getItem AID 
     * @param array $aryAidListe
     * @return integer
     */
    private function getItemAid( $aryAidListe )
    {
        foreach($aryAidListe as $intAidNumber => $aryItemInfo)
        {
            $intAID   = $intAidNumber;
            break;
        }
        
       return $intAID;
    }
    
    /**
     * getItemInfo
     * @param array $aryAidListe
     * @return array
     */
    private function getItemInfo( $aryAidListe )
    {
        foreach($aryAidListe as $intAidNumber => $aryItemInfo)
        {
            $itemInfo = $aryItemInfo;
            break;
        }
        
       return $itemInfo;
    }
    
    
    /**
     * Check Item in ItemFilter Array
     * @param  integer $intItemAID
     * @return boolean
     */
    private function checkItemFilter( $intItemAID )
    {
        if (in_array($intItemAID, self::$itemFilter))
                return true;
        
       return false;
    }
    
    /**
     * set Item Filter 
     * @param array $aryItemAIDs
     */
    private function setItemFilter ( $aryItemAIDs )
    {
        foreach($aryItemAIDs as $intItemAID)
        {
            $this->addItemToFilter($intItemAID);
        }
    }
    
    
    /**
     * Add Item to Filter
     * @param type $intItemAID
     */
    private function addItemToFilter( $intItemAID )
    {
        array_push(self::$itemFilter,$intItemAID);
    }
    
    private function getItemFilter()
    {
       $strFilter = self::EMPTY_STRING; 
        foreach(self::$itemFilter as $intAID)
        {
            $strFilter .= $intAID.'::';
        }
      return $strFilter;
    }
    
     /**
     * Add Item to Filter
     * @param type $intItemAID
     */
    private function addItemModifyListe( $intItemAID )
    {
        array_push(self::$itemModifyFilter,$intItemAID);
    }
    
    /**
     * get Item AID Modify Liste 
     */
    private function getItemModifyListe()
    {
        return array_unique(self::$itemModifyFilter);
    }
    
    /**
     * get Item Stack Size 
     * @param array $aryItemInfo
     * @return integer
     */
    private function getItemStack($aryItemInfo)
    {
        return $aryItemInfo['itemStack'];
    }
        
    /**
     * sub Item Stack
     * @param array $aryItemInfo
     * @param integer $intSubStack
     * @return array
     */
    private function subItemStack($aryItemInfo, $intSubStack)
    {
      $intOldItemStack = $aryItemInfo['itemStack'];
      $aryItemInfo['itemStack'] = $intOldItemStack - $intSubStack;

      return $aryItemInfo;  
    }
    
    /**
     * add Item Stack 
     * @param array $aryItemInfo
     * @param integer $intAddStack
     * @return array
     */
    private function addItemStack($aryItemInfo, $intAddStack)
    {
        $intOldItemStack = $aryItemInfo['itemStack'];
        $aryItemInfo['itemStack'] = $intOldItemStack + $intAddStack;

        return $aryItemInfo;
    }
    
    
    /**
     * add Item to Delete List
     * @param integer $intItemAID
     */
    private function deleteItem( $intItemAID )
    {
        array_push(self::$itemDeleteList,$intItemAID);
    }
    
     /**
     * get Item AID Delete Liste 
     */
    private function getItemDeleteListe()
    {
        return array_unique(self::$itemDeleteList);
    }
    
    /**
     * Check Item in Item Delete  Array
     * @param  integer $intItemAID
     * @return boolean
     */
    private function checkDeleteFilter( $intItemAID )
    {
        if (in_array($intItemAID, self::$itemDeleteList))
                return true;
        
       return false;
    }
    
    /**
     * Equal Items 
     * @param array $aryFirstItem
     * @param array $arySecondItem
     * @return boolean
     */
    private function itemEquals($aryFirstItem,$arySecondItem){
        
        if($aryFirstItem['itemId'] == $arySecondItem['itemId']){
            
            if($aryFirstItem['itemBytes'] == $arySecondItem['itemBytes'])
            {
                 if($aryFirstItem['itemDamage'] == $arySecondItem['itemDamage']){
                
                       return true;
                 }
                
            } 
        }
       
      return false;
    }
            
    
    /**
     * List of Player AID with Item Informations
     * @return array
     */
    private function getItemInformations()
    {
        $objItemInfoModel = $this->loadmodel('itemInfo');
        $playerItems = $this->getPlayerItems();
        
        $playerItemInformations = array();
        
        foreach($playerItems as $playerItemAid)
        {
           $aryItemInfo = $objItemInfoModel->getItemInfo($playerItemAid);
           array_push($playerItemInformations,array($playerItemAid => $aryItemInfo));
        }
        
      return $playerItemInformations;
    }
    
    /**
     * List of Player AID from Postbox or Storehouse
     * @return array
     */
    private function getPlayerItems()
    { 
        $ss = new Session();
        
        $objPlayerModel = $this->loadmodel('playerModel');
        $tblChanger     = $this->loadmodel('selecttable');
        $intPlayerId    = $objPlayerModel->getPlayerId();
        $strTableName   = $tblChanger->profilItemTablesviaName($ss->getSession('profilAction'));
        
        $strSql = $this->selectSqlData($strTableName, array('id'), array(
           
            'playerId' => $intPlayerId
            
        )); $itemResult = $this->getMysqlQuery($strSql);
        
        $allItemsFromPlayer = array();
        
        while($daten = mysql_fetch_array($itemResult)){
            array_push($allItemsFromPlayer,$daten['id']);
        }
        
       return $allItemsFromPlayer;
    }
    
 
}