<?php

class MoveItem extends Model
{
    public function __construct() {
        parent::__construct();
    }
    
    
    /**
     *  ajaxMoveItem
     */
    public function ajaxMoveItem()
    {
        if(isset($_GET['ids'])){
             
             $ajaxModel = $this->loadModel('ajax');
             $selectItem = $this->loadModel('ItemInfo');
             $aryItemsApsId = $ajaxModel->getCAPTA('ids');
             
             $objFactory = Factory::getFactory('message'); 
             
             if($_GET['ids'] == null){
                 $aryItemsApsId = array();
             }
             
             
             foreach($aryItemsApsId as $intItemAID)
             {        
                  if($selectItem->existsAidbyPlayer( $intItemAID , $this->getLoginPlayer())){
                     try{
                         
                        $this->moveItem($intItemAID);
                        
                     }catch(GlobalException $e)
                     {
                         $objFactory->addInformations($e->getArray());    
                     }
                  } 
             }
             
              $createMessage = $objFactory->Show(); 
              $this->getAjaxAssign('block_information', 'Move Informations');
              $this->getAjaxAssign('message',$createMessage);
              return true;
         }
       return false;
    }
    

    /**
     * Move Item into PostBox or StoreHouse
     * @param integer $intItemAID
     */
    public function moveItem($intItemAID)
    {
        $ss = new Session();
        $playerModel  = $this->loadmodel('playerModel');
        $tblChanger   = $this->loadmodel('selecttable');
        
        $intPlayerId        = $playerModel->getPlayerId();
        $currentTableName   = $tblChanger->profilItemTablesviaName($ss->getSession('profilAction'));
        $currentTableNumber = $tblChanger->getTableNumber($ss->getSession('profilAction'));
        
        if($currentTableNumber == self::TABLE_POSTBOX)
        {
            $moveToTable = $tblChanger->profilItemTablesviaId(self::TABLE_STOREHOUSE); 
            $strMoveTo   = self::TABLE_STOREHOUSE_STRING;
        }
        
        if($currentTableNumber == self::TABLE_STOREHOUSE || $currentTableNumber == self::TABLE_AUCTION){
            
            $moveToTable = $tblChanger->profilItemTablesviaId(self::TABLE_POSTBOX);  
            $strMoveTo   = self::TABLE_POSTBOX_STRING;
        }
        
        //Remove Item from currentTableName || Postbox  || Storehouse
        $strSql = $this->deleteSqlData($currentTableName, array(
           
            'id' => $intItemAID,
            'playerId' => $intPlayerId
            
        )); $this->getMysqlQuery($strSql);
        
         //Add Item to POSTBOX or STOREHOUSE
        $strSql = $this->insertSqlData($moveToTable, array(
           
            'id' => $intItemAID,
            'playerId' => $intPlayerId
            
        )); $this->getMysqlQuery($strSql);
        
        
         $exception = new GlobalException('MoveInfo',0,null);
         $exception->setArray(array(
                                
          'error' => 0,
          'info'  => array(
                     'aid'   =>  $intItemAID,
                     'move'  =>  $strMoveTo,
                     'mode'  =>  0
                     )
                                
        )); throw $exception;
        
    }
    
    /**
     * Move Item into AuctionHouse and
     * Remove from Postbox or Storehouse
     * @param integer $intItemAID
     */
    public function moveItemToAuctions($intItemAID)
    {
        $ss = new Session();
        $objPlayer = new Player();
        $tblChanger   = $this->loadmodel('selecttable');
        $intPlayerId      = $objPlayer->getPlayerId();
        $currentTableName = $tblChanger->profilItemTablesviaName($ss->getSession('profilAction'));
        $auctionTableName = $tblChanger->profilItemTablesviaId(self::TABLE_AUCTION);

        
        //Remove Item from currentTableName || Postbox  || Storehouse
        $strSql = $this->deleteSqlData($currentTableName, array(
           
            'id' => $intItemAID,
            'playerId' => $intPlayerId
            
        )); $this->getMysqlQuery($strSql);
        
        
        //Add Item to Auction
        $strSql = $this->insertSqlData($auctionTableName, array(
           
            'id' => $intItemAID,
            'playerId' => $intPlayerId
        )); $this->getMysqlQuery($strSql);
            
    }
    
        
}

?>
