<?php

class ViewCart extends Model
{
    private static $prefixCart = 'cart_';
    
    public function __construct() {
        parent::__construct();
    }
    
    public function ajaxViewCartBox()
    {
        // Init Session
        $ss = new Session(); 
        // loading Ajax Model 
        $ajaxModel = $this->loadModel('ajax');
        $aryItemsApsId = $ajaxModel->getCAPTA('ids');
               
        if(!isset($_SESSION['cart_session'])){
            $ss->createSession('cart_session', $aryItemsApsId);
        }else{
            
            $_SESSION['cart_session'] = array_merge($_SESSION['cart_session'],$aryItemsApsId);
            $_SESSION['cart_session'] = array_unique($_SESSION['cart_session']);
        }
        
        $intApsSize = count($_SESSION['cart_session']);
      
        // get more Item Infomations
        $selectItem   = $this->loadModel('ItemInfo');
        
        //Tax Status 
        $boolTaxStatus = true;  // Read Tax Status from DB
        
        //variable
        $summe      = self::_NULL;
        $subTotal   = self::_NULL;
        $taxPercent = 13;       // << Tax berechnen from DB 
        
        foreach($_SESSION['cart_session'] as $intApsId)
        {            
                   if($selectItem->isExistsDatabaseId($intApsId))
                    {
                        $aryItemInfo  = $selectItem->getItemInfo($intApsId);
                       
                            $subTotal = $subTotal + $aryItemInfo['itemPrice'];

                                if($boolTaxStatus){
                                        $summe  = ($subTotal / 100) * $taxPercent;
                                }else{
                                        $summe  = ($subTotal / 100);
                                }
                                        $summe  = $summe + $subTotal;
                    }
        }
        
        // Round Numbers
        $subTotalEnd      = number_format($subTotal,2,',','.');
        $summeTotalEnd    = number_format($summe,2,',','.');

        
        // set Placeholders
        $objOptionsModel = $this->loadModel('options');
        $this->getAjaxAssign(self::$prefixCart.'cItems',$intApsSize);
        $this->getAjaxAssign(self::$prefixCart.'tax',$taxPercent);
        $this->getAjaxAssign(self::$prefixCart.'subTotal',$subTotalEnd);
        $this->getAjaxAssign(self::$prefixCart.'summe',$summeTotalEnd);
        $this->getAjaxAssign(self::$prefixCart.'options',$objOptionsModel->ajaxOptions());
        
        
       return true;   
    }
    
    public function ajaxViewCartDetails()
    {
        // loading Ajax Model 
//        $ajaxModel = $this->loadModel('ajax');
//        $aryItemsApsId = $ajaxModel->getCAPTA('ids');
                
        // get more Item Infomations
        $selectItem   = $this->loadModel('ItemInfo');
        //default variable
        $item_liste = self::EMPTY_STRING;
        
        foreach($_SESSION['cart_session'] as $intApsId)
        {
               if($selectItem->isExistsDatabaseId($intApsId))
                    {
                        $aryItemInfo  = $selectItem->getItemInfo($intApsId);
                        
                            // Item Name
                            $strItemName  = $selectItem->getItemName($intApsId);
                        
                            $item_liste .= '
                                
                                 <li title="ItemID: '.$aryItemInfo['itemId'].' APS ID: '.$intApsId.'" class="d_li_box"> <span>'.$strItemName.' x'.$aryItemInfo['itemStack'].' </span> <a href="javascript:uncheck('.$intApsId.');"><img src="assets/img/rotes_x.gif" alt="remove item" title="remove item"></img></a></li>
                            ';
                         
                    }            
        }
        
        
        // set Placeholders
        $objOptionsModel = $this->loadModel('options');
        $this->getAjaxAssign(self::$prefixCart.'items',$item_liste);
        $this->getAjaxAssign(self::$prefixCart.'options',$objOptionsModel->ajaxOptions());
        
      return true;      
    }
    
    
    
}

?>